class IDList;
class RBF;
class Polyhedron{
 public:
  int numberV;
  int numberF;
  AxisKdTree *tree;
  PointSet *ps;
  Point3d **point;
  Point3d **cpoint;
  Point3d *t1;
  Point3d *t2;
  int *neighborL;
  int *neighborI;
  IDSet *IDtool;
  Point3d **normal;
  
  double eid[3];
  double **eia;
  double **eiv;
  
  int pickID;
  int Stype;
  int SNum;
  double me;
  double sig1,sig2,sig3;
  int **Face;
  PointTool *PT;
  Point3d **dc;
  double *simi;
  //error;
  int opti;

  Polyhedron(){
    opti=0;
    PT = new PointTool();
    IDtool = new IDSet();
    int i;
    
    dc = new Point3d* [10];
    for(i=0;i<10;i++)dc[i] = new Point3d(0.0,0.0,0.0);
    pickID=0;
    eia = new double* [3];eiv = new double* [3];
    for(i=0;i<3;i++){
      eia[i] = new double[3];
      eiv[i] = new double[3];
    }
  }
  
  void Similarity(int ID,double sig3,double *sim);
  void Gaussian(Point3d **in,Point3d **out,double sig2,double radi);
  void NLMean(double sig1,double sig2,double sig3);
  double Similariry(int i,int nowID,RBF *myRBF,Point3d *t1,Point3d *t2,double sigma33,IDList *LHead,IDList *LTail);
  void readmesh(char *filename);
  void savepoint(char *filename);
  void savesimilarity(char *filename);
  double getHeightVariation(int pickid);
  double getAverageHeightVariation();
  void addGaussianNoizeNormal(double mu,double sig);
  void makeNormals(Point3d **in);
  virtual ~Polyhedron(){
    int i;
    
    deletememory();
    delete IDtool;
    for(i=0;i<10;i++)delete dc[i];
    delete [] dc;
    delete PT;
    for(i=0;i<3;i++){
      delete [] eia[i];
      delete [] eiv[i];
    }
    delete [] eiv;
    delete [] eia;
  }
 private:
  void deletememory();
  
   Polyhedron(const Polyhedron& rhs);
  const Polyhedron &operator=(const Polyhedron& rhs);
  


};


