import java.awt.*;
import java.applet.*;
import java.util.*;
import java.awt.event.*;
import java.io.*;
import javax.media.j3d.*;
import javax.vecmath.*;
public class GMDecimation{
  int  numOK=0;
    int numCANCEL=0;
  int deciV=0;
  int deciF=0;
  int numE=0;
  int iterationnum=0;
  Vertices[] initialV;
  double ThresholdGamma=0.25;
  Vertices VHead;
  Vertices VTail;
  Triangle THead;
  Triangle TTail;
  
  
  NEList[] NEHead;
  NEList[] NETail;
  
  double maxenergy=0.0;
  double realmax=0.0;
  Edge[] Root;
  
  PriorityQueue pqueue;
  int HeapPointerN=0;
  int[] neighborI;
  
  Neighbor[] NHead;
  Neighbor[] NTail;
  Point3d[] point;
    Point3d[] laplace;
  
  int[] boundary;
  Point3d dummyv1;
  Point3d dummyv2;
  Point3d dummyv3;
  Point3d dummyv4;
  
  
  public GMDecimation(int nv1,int nv2,int[][] dFace,
	       Point3d[] rpoint,int[] rboundary, int[] rneighborI,Point3d[] rlaplace){
    int i,j;
    dummyv1 = new Point3d(0.0,0.0,0.0);
    dummyv2 = new Point3d(0.0,0.0,0.0);
    dummyv3 = new Point3d(0.0,0.0,0.0);
    dummyv4 = new Point3d(0.0,0.0,0.0);
     
    deciV = nv1; 
    deciF = nv2;
    numE = 0;
    InitV();
    InitT();
    
    
    point = rpoint;
    boundary = rboundary;
    neighborI = rneighborI;
    laplace = rlaplace;
    initialV = new Vertices[deciV];
    NHead = new Neighbor[deciV];
    NTail = new Neighbor[deciV];
    
    NEHead = new NEList[deciV];
    NETail = new NEList[deciV];
    
    Vertices now = VHead;
    
    for(i=0;i<deciV;i++){
      AppendV(i);
      now = next(now);
      initialV[i] = now;
      NHead[i] = new Neighbor();
      NTail[i] = new Neighbor();
      NHead[i].next = NTail[i];
      NTail[i].back = NHead[i];
      
      NEHead[i] = new NEList();
      NETail[i] = new NEList();
      NEHead[i].next = NETail[i];
      NETail[i].back = NEHead[i];
     
    }
    
    for(i=0;i<deciF;i++){
      if(dFace[i][0]>dFace[i][1])numE++;
      if(dFace[i][1]>dFace[i][2])numE++;
      if(dFace[i][2]>dFace[i][0])numE++;
    }
    
    Root = new Edge[numE];
    pqueue = new PriorityQueue(numE);
    HeapPointerN=0;
    System.out.println("Number of Edges: "+numE);
    Triangle nowt = THead;
    for(i=0;i<deciF;i++){
      AppendT(dFace[i][0],dFace[i][1],dFace[i][2]);
      
      nowt = next(nowt);
      if(dFace[i][0]>dFace[i][1])AppendE(initialV[dFace[i][0]],
					 initialV[dFace[i][1]]);
      if(dFace[i][1]>dFace[i][2])AppendE(initialV[dFace[i][1]],
					 initialV[dFace[i][2]]);
      if(dFace[i][2]>dFace[i][0])AppendE(initialV[dFace[i][2]],
					 initialV[dFace[i][0]]);
      
      AppendN(nowt,NTail[dFace[i][0]]);
      AppendN(nowt,NTail[dFace[i][1]]);
      AppendN(nowt,NTail[dFace[i][2]]);
    }
    maxenergy = Math.abs(pqueue.getmax())-10.0;
  }
  
  public void getVFace(Point3d[] subpoint,int[][] subFace){
    int i=0;
    Vertices now = VHead;
    while(next(now)!=VTail){
      now = next(now);
      if(now.EC){
	//System.out.println(+i);
	subpoint[i] = new Point3d(point[now.ID].x,
				  point[now.ID].y,
				  point[now.ID].z);
	now.ID = i;
	i++;	  
      }
    }
    i = 0;
    Triangle nowt = THead;
    while(next(nowt)!=TTail){
      
      nowt = next(nowt);
      if(nowt.EC){
	//System.out.println("i:"+i);
	subFace[i][0] = nowt.v1.ID;
	subFace[i][1] = nowt.v2.ID;
	subFace[i][2] = nowt.v3.ID;
	i++;
      }
    }
  }
  private void RemoveNeighbor(Triangle dt,int di,int dj){
    Neighbor now;
    int dtarget=dt.getV(di,dj);
    if(dtarget==-1){
      System.out.println("Error !!!");
      
    }else{
      now = NHead[dtarget];
      while(next(now)!=NTail[dtarget]){
	now = next(now);
	if(!(now.dt.EC)){
	  Remove(now);
	  break;
	}
      }
      NEList nowNE = NEHead[dtarget];
      while(next(nowNE)!=NETail[dtarget]){
	nowNE = next(nowNE);
	if(nowNE.de.vp1.ID==di||
	   nowNE.de.vp2.ID==di){
	  Remove(nowNE);
	  break;
	}
      }
    }    
  }
    
  public int getNowVNum(){
    return deciV;
  }
  
  
  private int getTnum(){
    int num=0;
    Triangle now = THead;
    while(next(now)!=TTail){
      now = next(now);
      num++;
    }
  
    return num;
  }
  public void Decimation(int objnum){
    Point3d mynewp = new Point3d(0.0,0.0,0.0);
   
    numOK=0;
    numCANCEL=0;
    while(deciV>objnum){
      
      if(Update(mynewp))break;
       iterationnum++;
       if(iterationnum>=numE){
	 break;
	/* iterationnum=0;
	 ThresholdGamma *= 0.99;
	 System.out.println("ThresholdGamma = "+ThresholdGamma);
	 for(int lm=0;lm<numE;lm++){
	   if(Root[lm].EC)
	     pqueue.HeapUpdate(Root[lm].idx,getEnergy(Root[lm].vp1.ID,
						      Root[lm].vp2.ID));
	 
	 }
	 */
       }
    }
   
    System.out.println("OK = "+numOK);
    System.out.println("CANCEL = "+numCANCEL);
   
    
  }
  
  
  
  
  private boolean Update(Point3d dv){
    int mypop = pqueue.Pop();
    
    if(mypop==-1)return true;
    Edge now = Root[mypop];
    if(now==null)return true;
    /*
     System.out.println(+now.de.ene);
    return false; */
    
    if(Consistency(now.vp1.ID,now.vp2.ID,dv)){
      
      EdgeCollapse(now.vp1.ID,now.vp2.ID,dv);
      
      numOK++;
    }else{
      pqueue.Put(mypop,realmax);
      numCANCEL++;
    }
    
    return false;
  }

  private double Size(Point3d dv){
    return Math.sqrt((dv.x*dv.x + dv.y*dv.y +dv.z*dv.z));
  }
  private double DistanceS(Point3d dv1,Point3d dv2){
    double dx = dv1.x - dv2.x;
    double dy = dv1.y - dv2.y;
    double dz = dv1.z - dv2.z;
    return (dx*dx+dy*dy+dz*dz);
  }
  private void EdgeCollapse(int i,int j,Point3d dv){
    
    
    Neighbor now;
    Neighbor tmp;
    NEList nowe;
    point[j].x = dv.x;
    point[j].y = dv.y;
    point[j].z = dv.z;

    /* 
       
       If T_{i} has two vertices (di and dj) then it neighbor 
       triangle is removed, and T_{i} real take EC = false. 
       
       */
    
    initialV[i].EC = false;
    
    now = NHead[j];
    while(next(now)!=NTail[j]){
      now = next(now);
      if(now.dt.HasTwoV(i,j)){
	now.dt.EC = false;
	deciF--;
	RemoveNeighbor((now.dt),i,j);
	tmp = back(now);
	Remove(now);
	now = tmp;
      }    
    }
    
    
    /* If T_{i} take EC = true then T_{around} is inserted to 
       vertex (dj) neighbor, and index di of T_{i} is changed to index dj. */
    
    now = NHead[i];
    while(next(now)!=NTail[i]){
      now = next(now);
      if(now.dt.EC){
	now.dt.changeItoJ(initialV[i],initialV[j]);
	AppendN((now.dt),NTail[j]);
      }
    }
    
    
    
    
    /* Remove and Add Neighbor Edges of T_{i} to T_{j} */
    
    nowe = NEHead[j];
    while(next(nowe)!=NETail[j]){
      nowe = next(nowe);
      if(nowe.de.vp1.ID == i||
	 nowe.de.vp2.ID == i){
	Remove(nowe);
	break;
      }
    }    

    nowe = NEHead[i];
    while(next(nowe)!=NETail[i]){
      nowe = next(nowe);
      //System.out.println(+nowe.de.vp1.ID+" "+nowe.de.vp2.ID);
      if(nowe.getV(i) != j){
	
	if(nowe.de.vp1==initialV[i]){
	  nowe.de.vp1 = initialV[j];
	}else if(nowe.de.vp2==initialV[i]){
	  nowe.de.vp2 = initialV[j];
	}
	AppendNE(nowe.de,NEHead[j],NETail[j]);
      }else{
	nowe.de.EC=false;
      }
    }
    
    /* Update 1-ring laplacians */
   
   // System.exit(0);
    
    
   NEList nowQi;
   int dtarget=-1;
   int neiQi=-1;
   
   double ldx = 0.0;
   double ldy = 0.0;
   double ldz = 0.0;
   int numnei=0;
   nowe = NEHead[j];
   while(next(nowe)!=NETail[j]){
      nowe = next(nowe);
      numnei++;
      dtarget = nowe.getV(j);
      ldx += (point[dtarget].x - point[j].x);
      ldy += (point[dtarget].y - point[j].y);
      ldz += (point[dtarget].z - point[j].z);
   }
   laplace[j].x = ldx/((double)(numnei));
   laplace[j].y = ldy/((double)(numnei));
   laplace[j].z = ldz/((double)(numnei));
   neighborI[j] = numnei;
   
   numnei = 0;
   nowe = NEHead[j];
   while(next(nowe)!=NETail[j]){
      nowe = next(nowe);
      dtarget = nowe.getV(j);
      ldx = 0.0;
      ldy = 0.0;
      ldz = 0.0;
      numnei=0;
      
      nowQi = NEHead[dtarget];
      while(next(nowQi)!=NETail[dtarget]){
	nowQi = next(nowQi);
	numnei++;
	neiQi = nowQi.getV(dtarget);
	
	
	if(neiQi==-1){
	  System.out.println("i = "+i+" j = "+j);
	  System.out.println(+nowe.de.vp1.ID+" "+nowe.de.vp2.ID);
	  if(nowe.de.EC)System.out.println("nowe = true");
	  else
	    System.out.println("nowe = false");
	  
	  System.out.println("dtarget = "+dtarget);
	  System.out.println(+nowQi.de.vp1.ID+" "+nowQi.de.vp2.ID);
	  if(nowQi.de.EC)System.out.println("nowQi = true");
	  else
	    System.out.println("nowQi = false");
	  System.out.println(" ");
	  NEList dumdum = NEHead[dtarget];
	   while(next(dumdum)!=NETail[dtarget]){
	     dumdum = next(dumdum);
	      System.out.println(+dumdum.de.vp1.ID+" "+dumdum.de.vp2.ID);
	   }
	}

	ldx += (point[neiQi].x - point[dtarget].x);
	ldy += (point[neiQi].y - point[dtarget].y);
	ldz += (point[neiQi].z - point[dtarget].z);
      }
      laplace[dtarget].x = ldx/((double)(numnei));
      laplace[dtarget].y = ldy/((double)(numnei));
      laplace[dtarget].z = ldz/((double)(numnei));
      neighborI[dtarget] = numnei;
   } 
    
       
   /* Update HeapData */
   
   
   double dene=0.0;
   
   nowe = NEHead[j];
   while(next(nowe)!=NETail[j]){
     nowe = next(nowe);
     dtarget = nowe.getV(j);     
     
     pqueue.HeapUpdate(nowe.de.idx,getEnergy(j,dtarget));
     
     /*
     nowQi = NEHead[dtarget];
     while(next(nowQi)!=NETail[dtarget]){
	nowQi = next(nowQi);
	neiQi = nowQi.getV(dtarget);
	
	pqueue.HeapUpdate(nowQi.de.idx,getEnergy(dtarget,neiQi));
	
	neiRj = NEHead[neiQi];
	while(next(neiRj)!=NETail[neiQi]){
	  neiRj = next(neiRj);
	  dtarget2 = neiRj.getV(neiQi);
	  if(neiRj.de.vp1.ID==neiQi){
	    dtarget2 = neiRj.de.vp2.ID;
	  }else if(neiRj.de.vp2.ID==neiQi){
	    dtarget2 = neiRj.de.vp1.ID;
	  }else{
	    System.out.println("BBB next(neiRj) Error !");
	  }
	  pqueue.HeapUpdate(neiRj.de.idx,getEnergy(neiQi,dtarget2));
	}
	
	
      }*/
   }

   deciV--;
   
  }
    /*
  private void Bilaplace(int j){

    NEList nowQi;
    int dtarget=-1;
    int neiQi=-1;
    
    double ldx = 0.0;
    double ldy = 0.0;
    double ldz = 0.0;
    int numnei=0;
   NEList nowe = NEHead[j];
   while(next(nowe)!=NETail[j]){
     nowe = next(nowe);
      numnei++;
      dtarget = nowe.getV(j);
      ldx += (point[dtarget].x - point[j].x);
      ldy += (point[dtarget].y - point[j].y);
      ldz += (point[dtarget].z - point[j].z);
   }
   laplace[j].x = ldx/((double)(numnei));
   laplace[j].y = ldy/((double)(numnei));
   laplace[j].z = ldz/((double)(numnei));
   neighborI[j] = numnei;
   
   numnei = 0;
   nowe = NEHead[j];
   while(next(nowe)!=NETail[j]){
      nowe = next(nowe);
      dtarget = nowe.getV(j);
      ldx = 0.0;
      ldy = 0.0;
      ldz = 0.0;
      numnei=0;
      
      nowQi = NEHead[dtarget];
      while(next(nowQi)!=NETail[dtarget]){
	nowQi = next(nowQi);
	numnei++;
	neiQi = nowQi.getV(dtarget);
	ldx += (point[neiQi].x - point[dtarget].x);
	ldy += (point[neiQi].y - point[dtarget].y);
	ldz += (point[neiQi].z - point[dtarget].z);
      }
      laplace[dtarget].x = ldx/((double)(numnei));
      laplace[dtarget].y = ldy/((double)(numnei));
      laplace[dtarget].z = ldz/((double)(numnei));
      neighborI[dtarget] = numnei;
   } 
    
    
   
   
   ldx = 0.0;
   ldy = 0.0;
   ldz = 0.0;
   nowe = NEHead[j];
   while(next(nowe)!=NETail[j]){
     nowe = next(nowe);
     dtarget = nowe.getV(j);
     ldx += (laplace[dtarget].x - laplace[j].x);
     ldy += (laplace[dtarget].y - laplace[j].y);
     ldz += (laplace[dtarget].z - laplace[j].z);
     
   }
   BiL[j].x = ldx/((double)(neighborI[j]));
   BiL[j].y = ldy/((double)(neighborI[j]));
   BiL[j].z = ldz/((double)(neighborI[j]));
   

   point[j].x -= 0.5*BiL[j].x;
   point[j].y -= 0.5*BiL[j].y;
   point[j].z -= 0.5*BiL[j].z;

  }
    */
  private void CrossVector(Point3d out,Point3d in1,Point3d in2){
    out.x = (in1.y*in2.z - in2.y*in1.z);
    out.y = (in1.z*in2.x - in2.z*in1.x);
    out.z = (in1.x*in2.y - in2.x*in1.y);
  }
  private void setNormal(Point3d dln,int i,int j,Point3d newp,Point3d dv1,Point3d dv2){
    
      dv1.x = (point[i].x-newp.x);
      dv1.y = (point[i].y-newp.y);
      dv1.z = (point[i].z-newp.z);
      dv2.x = (point[j].x-newp.x);
      dv2.y = (point[j].y-newp.y);
      dv2.z = (point[j].z-newp.z);
    CrossVector(dln,dv1,dv2);
  }
  private boolean Consistency(int i,int j,Point3d dv){
    //if(boundary[i]==1||boundary[j]==1)return false;
    setNewPosition(i,j,dv);
    /*
    dv.x = 0.5*(point[i].x + point[j].x);
    dv.y = 0.5*(point[i].y + point[j].y);
    dv.z = 0.5*(point[i].z + point[j].z); 
    */

    //System.out.println(+dv.x+" "+dv.y+" "+dv.z);
    int dk1,dk2;
    
    dummyv4.x = 0.0;
    dummyv4.y = 0.0;
    dummyv4.z = 0.0;
    
    double dsize=0.0;
    //double ThresholdGamma=1.0;
    double Gamma=0.0;
    
    Neighbor now = NHead[i];
    while(next(now)!=NTail[i]){
      now = next(now);
      
      if(!(now.dt.HasTwoV(i,j))){
	dk1 = now.dt.getV1(i);
	dk2 = now.dt.getV2(i);
	//System.out.println("i :"+i+" j: "+j+" dk1: "+dk1+" dk2: "+dk2);
	if(dk1==-1||dk2==-1){
	  System.out.println("i :"+i+" j: "+j);
	  System.out.println(+now.dt.v1.ID+" "+now.dt.v2.ID+" "+now.dt.v3.ID);
	  if(now.dt.EC){
	    System.out.println("TRUE");}else{
	      System.out.println("FALSE");
	    }
	}
	
	setNormal(dummyv3,dk1,dk2,dv,dummyv1,dummyv2);
	dummyv4.x += dummyv3.x;
	dummyv4.y += dummyv3.y;
	dummyv4.z += dummyv3.z;
	Gamma = ((2.0*Math.sqrt(3.0)*Size(dummyv3))/
		 (DistanceS(dv,point[dk1])+DistanceS(dv,point[dk2])
		  +DistanceS(point[dk1],point[dk2])));
	//if(Gamma<0.1)System.out.println(+i+" "+j+" :"+Gamma);
	if(Gamma<=ThresholdGamma){
	  return false;
	}
      }
    }
    
    now = NHead[j];
    while(next(now)!=NTail[j]){
      now = next(now);
      
      if(!(now.dt.HasTwoV(i,j))){
	dk1 = now.dt.getV1(j);
	dk2 = now.dt.getV2(j);
	setNormal(dummyv3,dk1,dk2,dv,dummyv1,dummyv2);
	dummyv4.x += dummyv3.x;
	dummyv4.y += dummyv3.y;
	dummyv4.z += dummyv3.z;
	Gamma = ((2.0*Math.sqrt(3.0)*Size(dummyv3))/
		 (DistanceS(dv,point[dk1])+DistanceS(dv,point[dk2])
		  +DistanceS(point[dk1],point[dk2])));
	if(Gamma<=ThresholdGamma){
	  return false;
	}
      }
    }
    dsize = Size(dummyv4);
    if(dsize==0.0)dsize=1.0;
    dummyv4.x /= dsize;
    dummyv4.y /= dsize;
    dummyv4.z /= dsize;
    
    
    now = NHead[i];
    while(next(now)!=NTail[i]){
      now = next(now);
      
      if(!(now.dt.HasTwoV(i,j))){
	dk1 = now.dt.getV1(i);
	dk2 = now.dt.getV2(i);
	dummyv1.x = 0.5*(point[dk1].x+point[dk2].x)+dummyv4.x;
	dummyv1.y = 0.5*(point[dk1].y+point[dk2].y)+dummyv4.y;
	dummyv1.z = 0.5*(point[dk1].z+point[dk2].z)+dummyv4.z;
	if(PlaneSize(point[dk1],point[dk2],dummyv1,dv))return false;
      }
    }
    now = NHead[j];
    while(next(now)!=NTail[j]){
      now = next(now);
      
      if(!(now.dt.HasTwoV(i,j))){
	dk1 = now.dt.getV1(j);
	dk2 = now.dt.getV2(j);
	dummyv1.x = 0.5*(point[dk1].x+point[dk2].x)+dummyv4.x;
	dummyv1.y = 0.5*(point[dk1].y+point[dk2].y)+dummyv4.y;
	dummyv1.z = 0.5*(point[dk1].z+point[dk2].z)+dummyv4.z;
	if(PlaneSize(point[dk1],point[dk2],dummyv1,dv))return false;
      }
    }
    

    return true;
  }
  private boolean PlaneSize(Point3d p1,Point3d p2,Point3d p3,Point3d ep){
   double dv = (-ep.z*p1.y*p2.x + ep.y*p1.z*p2.x + ep.z*p1.x*p2.y - 
		ep.x*p1.z*p2.y - ep.y*p1.x*p2.z + ep.x*p1.y*p2.z + 
		ep.z*p1.y*p3.x - ep.y*p1.z*p3.x - ep.z*p2.y*p3.x + 
		p1.z*p2.y*p3.x + ep.y*p2.z*p3.x - p1.y*p2.z*p3.x - 
		ep.z*p1.x*p3.y + ep.x*p1.z*p3.y + ep.z*p2.x*p3.y - 
		p1.z*p2.x*p3.y - ep.x*p2.z*p3.y + p1.x*p2.z*p3.y + 
		ep.y*p1.x*p3.z - ep.x*p1.y*p3.z - ep.y*p2.x*p3.z + 
		p1.y*p2.x*p3.z + ep.x*p2.y*p3.z - p1.x*p2.y*p3.z);
   
   //System.out.println(+dv);
   if(dv>0.0)return true;
   return false;
  }
  private double setPType1(int dk1,Point3d dv,int i, int j){
    Point3d dlap = new Point3d(0.0,0.0,0.0);
      
      int tar=-1;
      double tmpto=0.0;
      
      NEList now = NEHead[dk1];
      while(next(now)!=NETail[dk1]){
	now = next(now);
	tar = now.getV(dk1);
	if(tar != i && tar !=j){
	  dlap.x += point[tar].x;
	  dlap.y += point[tar].y;
	  dlap.z += point[tar].z;
	  tmpto += 1.0;
	}
      }
      tmpto+=1.0;
      dv.x += (2.0*point[dk1].x - (1.0/tmpto)*dlap.x);
      dv.y += (2.0*point[dk1].y - (1.0/tmpto)*dlap.y);
      dv.z += (2.0*point[dk1].z - (1.0/tmpto)*dlap.z);
      return (1.0/tmpto);
  }
    private void setNewPosition(int i,int j,Point3d dv){
	int dk1=0;
	int dk2=0;
	double dlx = laplace[i].x + laplace[j].x;
	double dly = laplace[i].y + laplace[j].y;
	double dlz = laplace[i].z + laplace[j].z;
	double px = 0.5*(point[i].x + point[j].x);
	double py = 0.5*(point[i].y + point[j].y);
	double pz = 0.5*(point[i].z + point[j].z);
	IDList myh = new IDList();
	IDList myt = new IDList();
	myh.next = myt;
	myt.back = myh;
	double tmpnum=0.0;
	NEList now = NEHead[i];
	
	while(next(now)!=NETail[i]){
	    now = next(now);
	    dk1 = now.getV(i);
	    if(dk1!=j){
		
		tmpnum += 1.0;
		AppendI(dk1,myt);
	    }
	}
	double dx,dy,dz;
	now = NEHead[j];
	while(next(now)!=NETail[j]){
	    now = next(now);
	    dk1 = now.getV(j);
	    if(dk1!=i&&AppendI(dk1,myh,myt)){
		tmpnum += 1.0;
	    }
	}
	IDList now2=null;
	int k=0;
	for(k=0;k<30;k++){
	    dx = 0.0;
	    dy = 0.0;
	    dz = 0.0;
	    now2 = myh;
	    while(next(now2)!=myt&&now2.ID!=-1){
		now2 = next(now2);
		if(now2.ID==-1)break;
		System.out.println("ID = "+now2.ID);
		dx += point[now2.ID].x - px;
		dy += point[now2.ID].y - py;
		dz += point[now2.ID].z - pz;
		
	    }
	    dx /= tmpnum;
	    dy /= tmpnum;
	    dz /= tmpnum;
	    
	    px += 0.5*(dx - dlx);
	    py += 0.5*(dy - dly);
	    pz += 0.5*(dz - dlz);
		
	}
	
	dv.x = px;
	dv.y = py;
	dv.z = pz;
	
    }
    
    /*
  private void setNewPosition(int i,int j,Point3d dv){
    int dk1=0;
    int dk2=0;
    
    
    double totaltmp = 0.0;
    
    if(boundary[i]==1&&boundary[j]==1){
      dv.x = 0.5*(point[i].x + point[j].x);
      dv.y = 0.5*(point[i].y + point[j].y);
      dv.z = 0.5*(point[i].z + point[j].z);
    }else if(boundary[i]==1&&boundary[j]!=1){
      dv.x = point[i].x;
      dv.y = point[i].y;
      dv.z = point[i].z;
      
    }else if(boundary[i]!=1&&boundary[j]==1){
      dv.x = point[j].x;
      dv.y = point[j].y;
      dv.z = point[j].z;
    }else{
      dv.x = 0.0;
      dv.y = 0.0;
      dv.z = 0.0;
      totaltmp = 0.0;
      double tmpnum=0.0;
      IDList myh = new IDList();
      IDList myt = new IDList();
      myh.next = myt;
      myt.back = myh;
      
      NEList now = NEHead[i];
      
      while(next(now)!=NETail[i]){
	now = next(now);
	dk1 = now.getV(i);
	if(dk1!=j){
	  
	  totaltmp += setPType1(dk1,dv,i,j);
	  tmpnum += 1.0;
	  AppendI(dk1,myt);
	}
      }
      
      now = NEHead[j];
      while(next(now)!=NETail[j]){
	now = next(now);
	dk1 = now.getV(j);
	if(dk1!=i&&AppendI(dk1,myh,myt)){
	  totaltmp += setPType1(dk1,dv,i,j);
	  tmpnum += 1.0;
	}
      }
            
      if(tmpnum==0.0)tmpnum=1.0;
      dv.x /= (tmpnum+totaltmp);
      dv.y /= (tmpnum+totaltmp);
      dv.z /= (tmpnum+totaltmp);
      
            
    }
    
  }
    */
   /* 
      private void setNewPosition(int i,int j,Point3d dv){
    int dk1,dk2;
        
    double tmp1 = 0.0;
    double tmp2 = 0.0;
    double tmp3 = 0.0;
    double totaltmp = 0.0;
    
    if(boundary[i]==1&&boundary[j]==1){
      dv.x = 0.5*(point[i].x + point[j].x);
      dv.y = 0.5*(point[i].y + point[j].y);
      dv.z = 0.5*(point[i].z + point[j].z);
    }else if(boundary[i]==1&&boundary[j]!=1){
      dv.x = point[i].x;
      dv.y = point[i].y;
      dv.z = point[i].z;
      
    }else if(boundary[i]!=1&&boundary[j]==1){
      dv.x = point[j].x;
      dv.y = point[j].y;
      dv.z = point[j].z;
    }else{
    dv.x = 0.0;
    dv.y = 0.0;
    dv.z = 0.0;
      Neighbor now = NHead[i];
      while(next(now)!=NTail[i]){
	now = next(now);
	
	if(now.dt.HasTwoV(i,j)){
	  
	  dk1 = now.dt.getV(i,j);
	  tmp1 = (1.0/((double)(neighborI[dk1]-1)));
	  
	  totaltmp += tmp1;
	 
	  dv.x += (2.0*point[dk1].x - tmp1*(((double)(neighborI[dk1]-1))*(laplace[dk1].x + point[dk1].x) - (point[i].x + point[j].x)));
	  dv.y += (2.0*point[dk1].y - tmp1*(((double)(neighborI[dk1]-1))*(laplace[dk1].y + point[dk1].y) - (point[i].y + point[j].y)));
	  dv.z += (2.0*point[dk1].z - tmp1*(((double)(neighborI[dk1]-1))*(laplace[dk1].z + point[dk1].z) - (point[i].z + point[j].z)));
	  tmp3+=1.0;
	}else{
	  dk1 = now.dt.getV1(i);
	  dk2 = now.dt.getV2(i);
	  tmp1 = (1.0/((double)(neighborI[dk1])));
	  
	  totaltmp += tmp1;
	  
	  dv.x += (2.0*point[dk1].x - tmp1*(((double)(neighborI[dk1]))*(laplace[dk1].x + point[dk1].x) - point[i].x));
	  dv.y += (2.0*point[dk1].y - tmp1*(((double)(neighborI[dk1]))*(laplace[dk1].y + point[dk1].y) - point[i].y));
	  dv.z += (2.0*point[dk1].z - tmp1*(((double)(neighborI[dk1]))*(laplace[dk1].z + point[dk1].z) - point[i].z));
	  
	  tmp1 = (1.0/((double)(neighborI[dk2])));
	  
	  totaltmp += tmp1;
	  
	  dv.x += (2.0*point[dk2].x - tmp1*(((double)(neighborI[dk2]))*(laplace[dk2].x + point[dk2].x) - point[i].x));
	  dv.y += (2.0*point[dk2].y - tmp1*(((double)(neighborI[dk2]))*(laplace[dk2].y + point[dk2].y) - point[i].y));
	  dv.z += (2.0*point[dk2].z - tmp1*(((double)(neighborI[dk2]))*(laplace[dk2].z + point[dk2].z) - point[i].z));
	  
	

	tmp3+=2.0;
	}
      }
      
      
    now = NHead[j];
      while(next(now)!=NTail[j]){
	now = next(now);
	
	if(now.dt.HasTwoV(i,j)){
	  
	  dk1 = now.dt.getV(i,j);
	  tmp1 = (1.0/((double)(neighborI[dk1]-1)));
	  
	  totaltmp += tmp1;
	 
	  dv.x += (2.0*point[dk1].x - tmp1*(((double)(neighborI[dk1]-1))*(laplace[dk1].x + point[dk1].x) - (point[i].x + point[j].x)));
	  dv.y += (2.0*point[dk1].y - tmp1*(((double)(neighborI[dk1]-1))*(laplace[dk1].y + point[dk1].y) - (point[i].y + point[j].y)));
	  dv.z += (2.0*point[dk1].z - tmp1*(((double)(neighborI[dk1]-1))*(laplace[dk1].z + point[dk1].z) - (point[i].z + point[j].z)));
	  tmp3+=1.0;
	}else{
	  dk1 = now.dt.getV1(j);
	  dk2 = now.dt.getV2(j);
	  tmp1 = (1.0/((double)(neighborI[dk1])));
	  
	  totaltmp += tmp1;
	  
	  dv.x += (2.0*point[dk1].x - tmp1*(((double)(neighborI[dk1]))*(laplace[dk1].x + point[dk1].x) - point[j].x));
	  dv.y += (2.0*point[dk1].y - tmp1*(((double)(neighborI[dk1]))*(laplace[dk1].y + point[dk1].y) - point[j].y));
	  dv.z += (2.0*point[dk1].z - tmp1*(((double)(neighborI[dk1]))*(laplace[dk1].z + point[dk1].z) - point[j].z));
	  
	  tmp1 = (1.0/((double)(neighborI[dk2])));
	  
	  totaltmp += tmp1;
	  
	  dv.x += (2.0*point[dk2].x - tmp1*(((double)(neighborI[dk2]))*(laplace[dk2].x + point[dk2].x) - point[j].x));
	  dv.y += (2.0*point[dk2].y - tmp1*(((double)(neighborI[dk2]))*(laplace[dk2].y + point[dk2].y) - point[j].y));
	  dv.z += (2.0*point[dk2].z - tmp1*(((double)(neighborI[dk2]))*(laplace[dk2].z + point[dk2].z) - point[j].z));
	  
	  
	

	tmp3+=2.0;
	}
      }
      
      
    
    
      
      tmp1 = (1.0 - (1.0/tmp3)*totaltmp);
    
    dv.x *= (1.0/tmp3);
    dv.y *= (1.0/tmp3);
    dv.z *= (1.0/tmp3);
    dv.x /= tmp1;
    dv.y /= tmp1;
    dv.z /= tmp1;
    
    }

  }

    
      */
  /*
  private void setNewPosition(int i,int j,Point3d dv,Point3d dummy){
    int dk1,dk2;
    dummy.x = 0.0;
    dummy.y = 0.0;
    dummy.z = 0.0;
    
    double dumNI=0.0;
    double dtemp1=0.0;
    double totalMnewW=0.0;
    dv.x = 0.0;
    dv.y = 0.0;
    dv.z = 0.0;
    if(boundary[i]==1&&boundary[j]==1){
      dv.x = 0.5*(point[i].x + point[j].x);
      dv.y = 0.5*(point[i].y + point[j].y);
      dv.z = 0.5*(point[i].z + point[j].z);
    }else if(boundary[i]==1&&boundary[j]!=1){
      dv.x = point[i].x;
      dv.y = point[i].y;
      dv.z = point[i].z;
      
    }else if(boundary[i]!=1&&boundary[j]==1){
      dv.x = point[j].x;
      dv.y = point[j].y;
      dv.z = point[j].z;
    }else{
    
    Neighbor now = NHead[i];
    while(next(now)!=NTail[i]){
      now = next(now);
      
      if(now.dt.HasTwoV(i,j)){
	
	dk1 = now.dt.getV(i,j);
	dumNI = ((double)(neighborI[dk1]));
	dtemp1 = ((dumNI)/(dumNI-2.0));
	dummy.x = ((laplace[dk1].x-(1.0/dumNI)*
		     (point[i].x+point[j].x-point[dk1].x))*dtemp1);
	dummy.y = ((laplace[dk1].y-(1.0/dumNI)*
		     (point[i].y+point[j].y-point[dk1].y))*dtemp1);
	dummy.z = ((laplace[dk1].z-(1.0/dumNI)*
		     (point[i].z+point[j].z-point[dk1].z))*dtemp1);
	dtemp1 = (1.0+(1.0/(dumNI-2.0)));
	totalMnewW += dtemp1;
	
	dv.x += (dtemp1*point[dk1].x - dummy.x);
	dv.y += (dtemp1*point[dk1].y - dummy.y);
	dv.z += (dtemp1*point[dk1].z - dummy.z);
      }else{
	dk1 = now.dt.getV1(i);
	dk2 = now.dt.getV2(i);
	dumNI = ((double)(neighborI[dk1]));
	dtemp1 = ((dumNI)/(dumNI-1.0));
	dummy.x = ((laplace[dk1].x-(1.0/dumNI)*
		    (point[i].x-point[dk1].x))*dtemp1);
	dummy.y = ((laplace[dk1].y-(1.0/dumNI)*
		    (point[i].y-point[dk1].y))*dtemp1);
	dummy.z = ((laplace[dk1].z-(1.0/dumNI)*
		    (point[i].z-point[dk1].z))*dtemp1);
	dtemp1 = (1.0+(1.0/(dumNI-1.0)));
	totalMnewW += dtemp1;
	dv.x += (dtemp1*point[dk1].x - dummy.x);
	dv.y += (dtemp1*point[dk1].y - dummy.y);
	dv.z += (dtemp1*point[dk1].z - dummy.z);
	dumNI = ((double)(neighborI[dk2]));
	dtemp1 = ((dumNI)/(dumNI-1.0));
	dummy.x = ((laplace[dk2].x-(1.0/dumNI)*
		    (point[i].x-point[dk2].x))*dtemp1);
	dummy.y = ((laplace[dk2].y-(1.0/dumNI)*
		    (point[i].y-point[dk2].y))*dtemp1);
	dummy.z = ((laplace[dk2].z-(1.0/dumNI)*
		    (point[i].z-point[dk2].z))*dtemp1);
	dtemp1 = (1.0+(1.0/(dumNI-1.0)));
	totalMnewW += dtemp1;
	dv.x += (dtemp1*point[dk2].x - dummy.x);
	dv.y += (dtemp1*point[dk2].y - dummy.y);
	dv.z += (dtemp1*point[dk2].z - dummy.z);
      }
    }
    

    now = NHead[j];
       
    while(next(now)!=NTail[j]){
      now = next(now);
      
      if(now.dt.HasTwoV(i,j)){
	
	dk1 = now.dt.getV(i,j);
	dumNI = ((double)(neighborI[dk1]));
	dtemp1 = ((dumNI)/(dumNI-2.0));
	dummy.x = ((laplace[dk1].x-(1.0/dumNI)*
		     (point[j].x+point[j].x-point[dk1].x))*dtemp1);
	dummy.y = ((laplace[dk1].y-(1.0/dumNI)*
		     (point[j].y+point[j].y-point[dk1].y))*dtemp1);
	dummy.z = ((laplace[dk1].z-(1.0/dumNI)*
		     (point[j].z+point[j].z-point[dk1].z))*dtemp1);
	dtemp1 = (1.0+(1.0/(dumNI-2.0)));
	totalMnewW += dtemp1;
	
	dv.x += (dtemp1*point[dk1].x - dummy.x);
	dv.y += (dtemp1*point[dk1].y - dummy.y);
	dv.z += (dtemp1*point[dk1].z - dummy.z);
      }else{
	dk1 = now.dt.getV1(j);
	dk2 = now.dt.getV2(j);
	dumNI = ((double)(neighborI[dk1]));
	dtemp1 = ((dumNI)/(dumNI-1.0));
	dummy.x = ((laplace[dk1].x-(1.0/dumNI)*
		    (point[j].x-point[dk1].x))*dtemp1);
	dummy.y = ((laplace[dk1].y-(1.0/dumNI)*
		    (point[j].y-point[dk1].y))*dtemp1);
	dummy.z = ((laplace[dk1].z-(1.0/dumNI)*
		    (point[j].z-point[dk1].z))*dtemp1);
	dtemp1 = (1.0+(1.0/(dumNI-1.0)));
	totalMnewW += dtemp1;
	dv.x += (dtemp1*point[dk1].x - dummy.x);
	dv.y += (dtemp1*point[dk1].y - dummy.y);
	dv.z += (dtemp1*point[dk1].z - dummy.z);
	dumNI = ((double)(neighborI[dk2]));
	dtemp1 = ((dumNI)/(dumNI-1.0));
	dummy.x = ((laplace[dk2].x-(1.0/dumNI)*
		    (point[j].x-point[dk2].x))*dtemp1);
	dummy.y = ((laplace[dk2].y-(1.0/dumNI)*
		    (point[j].y-point[dk2].y))*dtemp1);
	dummy.z = ((laplace[dk2].z-(1.0/dumNI)*
		    (point[j].z-point[dk2].z))*dtemp1);
	dtemp1 = (1.0+(1.0/(dumNI-1.0)));
	totalMnewW += dtemp1;
	dv.x += (dtemp1*point[dk2].x - dummy.x);
	dv.y += (dtemp1*point[dk2].y - dummy.y);
	dv.z += (dtemp1*point[dk2].z - dummy.z);
      }
    }
    
    totalMnewW *= 0.5;
    dv.x *= 0.5;
    dv.y *= 0.5;
    dv.z *= 0.5;
    dv.x /= totalMnewW;
    dv.y /= totalMnewW;
    dv.z /= totalMnewW;
  }

  }
  */
  
  
  private void InitV(){
    VHead = new Vertices();
    VTail = new Vertices();
    VHead.next = VTail;
    VTail.back = VHead;
  }
  private void InitT(){
     THead = new Triangle();
    TTail = new Triangle();
    THead.next = TTail;
    TTail.back = THead;
  }
    
  private void AppendV(int dv){
    Vertices tmp = new Vertices(dv);
    Vertices tmp2 = VTail.back;
    tmp.back = tmp2;
    tmp2.next = tmp;
    tmp.next = VTail;
    VTail.back = tmp;
  }
  private double getSize(Point3d dv){
    return Math.sqrt((dv.x*dv.x + dv.y*dv.y + dv.z*dv.z));
  }
  private double getEnergy(int i,int j){
    double energy;
    energy = Math.sqrt(DistanceS(point[i],point[j])); 
     if(maxenergy>energy)maxenergy = energy-10.0;
     if(realmax<energy)realmax = energy+10.0;
       
    
    return energy;
  }

  private void AppendE(Vertices dv1,Vertices dv2){
    Edge tmp = new Edge(dv1,dv2);
    tmp.ene = getEnergy(dv1.ID,dv2.ID);
    tmp.idx = HeapPointerN;
    Root[HeapPointerN] = tmp;
    pqueue.Put(HeapPointerN,tmp.ene);
    HeapPointerN++;
    AppendNE(tmp,NETail[dv1.ID]);
    AppendNE(tmp,NETail[dv2.ID]); 
  }
  
  
   private void AppendNE(Edge dv,NEList dTail){
     NEList tmp = new NEList(dv);
     NEList tmp2 = dTail.back;
     tmp.back = tmp2;
     tmp2.next = tmp;
     tmp.next = dTail;
     dTail.back = tmp;
  }
 
 private boolean AppendI(int dv,IDList dhead,IDList dtail){
    IDList now = dhead;
    
    while(next(now)!=dtail){
      now = next(now);
      if(now.ID==dv){
	return false;
      }
    }    
    AppendI(dv,dtail);
    return true;
  }
  private void AppendI(int dv,IDList dtail){
    IDList tmp = new IDList(dv);
    IDList tmp2 = dtail.back;
    tmp.next = dtail;
    dtail.back = tmp;
    tmp.back = tmp2;
    tmp2.next = tmp;
  }
  
   private void AppendNE(Edge dv,NEList dHead,NEList dTail){
     NEList now = dHead;
     boolean mycheck=true;
     
     while(next(now)!=dTail){
       now = next(now);
       if(((now.de.vp1==dv.vp1)&&(now.de.vp2==dv.vp2))||
	  ((now.de.vp1==dv.vp2)&&(now.de.vp2==dv.vp1))){
	 mycheck = false;
	 double mymy = Root[dv.idx].ene;
	 pqueue.HeapUpdate(dv.idx,maxenergy);
	 int mymymy = pqueue.Pop();
	 Edge dddd = Root[mymymy];
	 
	 if(dddd.idx!=dv.idx){
	   System.out.println("dv.id = "+dv.idx+" dddd.idx = "+dddd.idx+" mymymy = "+mymymy+" Old(dv).w = "+mymy);
	   System.out.println("maxenergy = "+maxenergy+" dddd.w = "+dddd.ene);
	   System.out.println("AAAAAAAAAAAAAAAAAAAAAAAAAA");
	   
	   System.out.println("get: "+dddd.vp1.ID+" "+dddd.vp2.ID);
	   System.exit(0);
	 }
	 break;
       }
     }
     if(mycheck)AppendNE(dv,dTail);
   }
  
  

  private void AppendN(Triangle dv,Neighbor dTail){
    Neighbor tmp = new Neighbor(dv);
    Neighbor tmp2 = dTail.back;
    tmp.back = tmp2;
    tmp2.next = tmp;
    tmp.next = dTail;
    dTail.back = tmp;
  }
  
  private void AppendT(int dv1,int dv2,int dv3){
    Triangle tmp = new Triangle(initialV[dv1],initialV[dv2],initialV[dv3]);
    Triangle tmp2 = TTail.back;
    tmp.back = tmp2;
    tmp2.next = tmp;
    tmp.next = TTail;
    TTail.back = tmp;
  }
  
  private void Remove(Neighbor dv){
    Neighbor tmp1 = dv.back;
    Neighbor tmp2 = dv.next;
    tmp2.back = tmp1;
    tmp1.next = tmp2;
  }
  private void Remove(NEList dv){
    NEList tmp1 = dv.back;
    NEList tmp2 = dv.next;
    tmp2.back = tmp1;
    tmp1.next = tmp2;
  }
  
    
  private Vertices next(Vertices now)
    {
      return (now.next);
    }
  private Vertices back(Vertices now)
    {
      return (now.back);
    } 
  private Triangle next(Triangle now)
    {
      return (now.next);
    }
  private Triangle back(Triangle now)
    {
      return (now.back);
    } 
  private Neighbor next(Neighbor now)
    {
      return (now.next);
    }
  private Neighbor back(Neighbor now)
    {
      return (now.back);
    }  
  private Edge next(Edge now)
    {
      return (now.next);
    }
  private Edge back(Edge now)
    {
      return (now.back);
    }  
  
  private NEList next(NEList now)
    {
      return (now.next);
    }
  private NEList back(NEList now)
    {
      return (now.back);
    }
  private IDList next(IDList now)
    {
      return (now.next);
    }
  private IDList back(IDList now)
    {
      return (now.back);
    }

  class NEList implements java.io.Serializable{
    Edge de;
    NEList next;
    NEList back;
    public NEList(){
    }
    public NEList(Edge dv){
      de = dv;
    }
    public int getV(int i){
      if(de.vp1.ID==i){
	return de.vp2.ID;
      }else if(de.vp2.ID==i){
	return de.vp1.ID;
      }else{
	return -1;
      }
    }
  }
  class Vertices{
    
    Vertices next;
    Vertices back;
    int ID;
    boolean EC;
    Quadric error=null;
    public Vertices(){
      ID = -1;EC=false;
      error = new Quadric();
    }
    public Vertices(int dv){
      ID = dv;EC=true;
      error = new Quadric();
    }
    public void addABCD(Quadric dv){
      error.addQE(dv);
    }
    public double Quadric(Point3d dv){
      return error.Quadric(dv);
    }
  }
  class Quadric{
  double bx,by,bz;
  double dd;
  double a11,a12,a13,a22,a23,a33;
  
  public Quadric(){
    bx = 0.0;by=0.0;bz =0.0;dd=0.0;
    a11 = 0.0;a12 = 0.0;a13 = 0.0;a22 = 0.0;a23 = 0.0;a33 = 0.0;
  }
  
  public Quadric(double dva,double dvb,double dvc,double dvd,double weight){
    //weight = 1.0;
    bx = weight*dvd*dva;
    by = weight*dvd*dvb;
    bz = weight*dvd*dvc;
    dd = weight*dvd*dvd;
    a11 = weight*dva*dva; a12 = weight*dva*dvb; a13 = weight*dva*dvc;
    a22 = weight*dvb*dvb; a23 = weight*dvb*dvc;
    a33 = weight*dvc*dvc;
  }
  public boolean setNewPosition(Point3d dv){
    double dx,dy,dz;
    double divisor = (-a13*a13*a22 + 2.0*a12*a13*a23 - a11*a23*a23 - a12*a12*a33 + a11*a22*a33);
    //System.out.println("divisor: "+divisor);
    //if(Math.abs(divisor)<=0.0000001)return false;   
    if(Math.abs(divisor)<=0.000000000001)return false;   
    
    dx = -((-a23*a23 + a22*a33)*bx+(a13*a23 - a12*a33)*by
	  +(-a13*a22 + a12*a23)*bz)/divisor;
    dy = -((a13*a23 - a12*a33)*bx+(-a13*a13 + a11*a33)*by
	  +(a12*a13 - a11*a23)*bz)/divisor;
    dz = -((-a13*a22 + a12*a23)*bx+(a12*a13 - a11*a23)*by
	  +(-a12*a12 + a11*a22)*bz)/divisor;
    dv.x = dx;
    dv.y = dy;
    dv.z = dz;
    return true;
  }
  public void normalizeQE(double dv){
    bx /= dv;
    by /= dv;
    bz /= dv;
    dd /= dv;
    a11 /= dv;
    a12 /= dv;
    a13 /= dv;
    a22 /= dv;
    a23 /= dv;
    a33 /= dv;
  
  }
  public void UpdateQuadric(Quadric dv1,Quadric dv2){
    bx = dv1.bx + dv2.bx;
    by = dv1.by + dv2.by;
    bz = dv1.bz + dv2.bz;
    dd = dv1.dd + dv2.dd;
    a11 = dv1.a11 + dv2.a11; 
    a12 = dv1.a12 + dv2.a12; 
    a13 = dv1.a13 + dv2.a13;
    a22 = dv1.a22 + dv2.a22;
    a23 = dv1.a23 + dv2.a23;
    a33 = dv1.a33 + dv2.a33;
  }
  
  
  public void addQE(Quadric dv){
    bx += dv.bx;
    by += dv.by;
    bz += dv.bz;
    dd += dv.dd;
    a11 += dv.a11; a12 += dv.a12; a13 += dv.a13;
    a22 += dv.a22; a23 += dv.a23; a33 += dv.a33;
  }
  
  public double Quadric(Point3d dv){
    return (dd + 2.0*bx*dv.x + a11*dv.x*dv.x + 2.0*by*dv.y + 2.0*a12*dv.x*dv.y + 
     a22*dv.y*dv.y + 2.0*bz*dv.z + 2.0*a13*dv.x*dv.z + 2.0*a23*dv.y*dv.z + a33*dv.z*dv.z);
  }
  

}
  class PriorityQueue{
  HeapNode[] hlist;
  int[] hindex;
  int nodeN=0;
  int hpointerM=0;
  
  class HeapNode{
    double weight;
    int idx;
    public HeapNode(){
    }
  
    public HeapNode(int dv,double dw){
      idx = dv;
      weight = dw;
    }
  }

  
  public PriorityQueue(int dv){
    nodeN = dv;
    hlist = new HeapNode[nodeN];
    hindex = new int[nodeN];
    for(int i=0;i<nodeN;i++){
      hindex[i] = 0;
    }
  }
  public double getmax(){
    return hlist[0].weight;
  }
 private void swap(int i, int j) {
   HeapNode t;
   t = hlist[i];  
   hlist[i] = hlist[j];  
   hlist[j] = t;
   hindex[hlist[i].idx] = i;
   hindex[hlist[j].idx] = j;
 }
 
                            
 private void upheap(int i){
   int j;
   while (i != 0) {
     j = (((i)-1)/2);
     if (hlist[i].weight >= hlist[j].weight)
       break;
     swap(i,j);
     i = j;
   }
 }
 private void downheap(int i) {
   int j;
   while ((j = ((i)*2+1)) < hpointerM) {
     if(j+1 < hpointerM && hlist[j+1].weight < hlist[j].weight)
       j ++;
     if(hlist[j].weight >= hlist[i].weight)break;
     swap(i, j);
     i = j;
   }
 }
 
 public void Put(int idx, double w) {
   hlist[hpointerM] = new HeapNode(idx,w);
   hindex[idx] = hpointerM;
   hpointerM ++;
   upheap((hpointerM-1));
 }
 private HeapNode get(){
   HeapNode dv = hlist[0];
   hpointerM--;
   if(hpointerM<0)return null;
   hlist[0] = hlist[hpointerM];
   hindex[hlist[0].idx] = 0;
   downheap(0);
   return dv;
 }
 public void HeapUpdate(int idx, double w) {
   int i;  double oldv;
   i = hindex[idx];
   oldv = hlist[i].weight;
   hlist[i].weight = w;
   if(w < oldv){
     upheap(i);
   }else{
     downheap(i);
   }
 }
 public int Pop(){
   HeapNode tmp = this.get();
   if(tmp==null)return -1;
   return tmp.idx;
 }
  }
class Neighbor{
  Neighbor next;
  Neighbor back;
  Triangle dt;
  public Neighbor(Triangle dv){
    dt = dv;
    
  }
  public Neighbor(){
    dt=null;
  }
}
class Triangle{
 
  
  Triangle next;
  Triangle back;
  boolean EC;
  Vertices v1,v2,v3;
  
  Quadric error;
  double area;
  public Triangle(){
    v1=null;EC=false;
    v2=null;
    v3=null;
  }
  public Triangle(Vertices dv1,Vertices dv2,Vertices dv3){
    v1 = dv1;EC=true;
    v2 = dv2;
    v3 = dv3;
  }
  public void setABCD(Point3d dv1,Point3d dn){
    double size = Math.sqrt((dn.x*dn.x + dn.y*dn.y + dn.z*dn.z));
    if(size==0.0)size = 1.0;
    double dx = (dn.x/size);
    double dy = (dn.y/size);
    double dz = (dn.z/size);
    area = (size/2.0);
    error = new Quadric(dx,dy,dz,(-(dv1.x*dx+dv1.y*dy+dv1.z*dz)),(size/2.0));
    
    v1.addABCD(error);
    v2.addABCD(error);
    v3.addABCD(error);
    
  }
  
  public boolean HasTwoV(int di,int dj){
    if((v1.ID==di&&v2.ID==dj)||
       (v1.ID==dj&&v2.ID==di)||
       (v1.ID==di&&v3.ID==dj)||
       (v1.ID==dj&&v3.ID==di)||
       (v2.ID==di&&v3.ID==dj)||
       (v2.ID==dj&&v3.ID==di)){      
      return true;
    }else{
      return false;
    }
  }
  public int getV(int di,int dj){
    if((v1.ID==di&&v2.ID==dj)||
       (v1.ID==dj&&v2.ID==di)){
      return v3.ID;
    }else if((v1.ID==di&&v3.ID==dj)||
	     (v1.ID==dj&&v3.ID==di)){
      return v2.ID;
    }else if((v2.ID==di&&v3.ID==dj)||
	     (v2.ID==dj&&v3.ID==di)){      
      return v1.ID;
    }else{
      return -1;
    }
  }
  public int getV1(int di){
    if(v1.ID==di){
      return v2.ID;
    }else if(v2.ID==di){
      return v3.ID;
    }else if(v3.ID==di){
      return v1.ID;
    }else{
      return -1;
    }
  }
  public int getV2(int di){
    if(v1.ID==di){
      return v3.ID;
    }else if(v2.ID==di){
      return v1.ID;
    }else if(v3.ID==di){
      return v2.ID;
    }else{
      return -1;
    }
  }
  
  
  
  public void changeItoJ(Vertices dv1,Vertices dv2){
    if(v1==dv1){
      v1 = dv2;
    }else if(v2==dv1){
      v2 = dv2;
    }else if(v3==dv1){
      v3 = dv2;
    }else{
      
      System.out.println("Error 2 !!!!");
    }
  }
}
class Edge{
  Vertices vp1;
  Vertices vp2;
  double ene;
  int idx;
  boolean EC=true;
  Edge next=null;
  Edge back=null;
  public Edge(){
    vp1 = null;
    vp2 = null;
    ene = 0.0;
  }
  
  public Edge(Vertices dv1,Vertices dv2){
    vp1 = dv1;
    vp2 = dv2;
    ene = 0.0;
  }
  public Edge(Vertices dv1,Vertices dv2,double dene){
    vp1 = dv1;
    vp2 = dv2;
    ene = dene;
  }
  
}
}
