import java.awt.*;
import java.applet.*;
import java.util.*;
import java.awt.event.*;
import java.io.*;
import javax.media.j3d.*;
import javax.vecmath.*;
public class ModGHDMesh{
  int  numOK=0;
  int numCANCEL=0;
  int deciV=0;
  int deciF=0;
  int numE=0;
  int iterationnum=0;
  Vertices[] initialV=null;
  double ThresholdGamma=0.15;


  
  Vertices VHead=null;
  Vertices VTail=null;
  Triangle THead=null;
  Triangle TTail=null;
  NEList[] NEHead=null;
  NEList[] NETail=null;
  double maxenergy=0.0;
  double realmax=0.0;
  Edge[] Root=null;
  PriorityQueue pqueue=null;
  int HeapPointerN=0;
  
  
  Neighbor[] NHead=null;
  Neighbor[] NTail=null;
  Point3d[] point=null;
  final int restriction = 8;
  
  int[] boundary=null;
  Quadric dummyQE=null;
  Point3d dummyv1=null;
  Point3d dummyv2=null;
  Point3d dummyv3=null;
  Point3d dummyv4=null;
  IDList[] FHead=null;
  IDList[] FTail=null;
  int[] neighborF=null;
  public ModGHDMesh(){
    numOK=0;
    numCANCEL=0;
    deciV=0;
    deciF=0;
    numE=0;
    iterationnum=0;
    initialV=null;
    ThresholdGamma=0.15;


  
    VHead=null;
  VTail=null;
  THead=null;
  TTail=null;
  NEHead=null;
  NETail=null;
  maxenergy=0.0;
  realmax=0.0;
  Root=null;
  pqueue=null;
  HeapPointerN=0;
  
  
  NHead=null;
  NTail=null;
  point=null;
  
  
  boundary=null;
  dummyQE=null;
  dummyv1=null;
  dummyv2=null;
  dummyv3=null;
  dummyv4=null;
  FHead=null;
  FTail=null;
  neighborF=null;
  
  }
  public void SetModGHDMesh(int nv1,int nv2,int[][] dFace,
			    Point3d[] rpoint,int[] rboundary,IDList[] dFHead,
			    IDList[] dFTail,int[] dneighborF){
    /*
    FHead = dFHead;
    FTail = dFTail;
    neighborF = dneighborF;
    */
    int i,j;
    deciV = nv1; 
    deciF = nv2;
    FHead = new IDList[deciV];
    FTail = new IDList[deciV];
    point = new Point3d[deciV];
    boundary = new int[deciV];
    neighborF = new int[deciV];
    IDList nowid = null;
    for(i=0;i<deciV;i++){
      neighborF[i] = dneighborF[i];
      point[i] = new Point3d(rpoint[i].x,rpoint[i].y,rpoint[i].z);
      boundary[i] = rboundary[i];
      FHead[i] = new IDList();
      FTail[i] = new IDList();
      FHead[i].next = FTail[i];
      FTail[i].back = FHead[i];
      nowid = dFHead[i];
      while(next(nowid)!=dFTail[i]){
	nowid = next(nowid);
	AppendVF(nowid.ID,FTail[i]);
      }
    }
    
    dummyv1 = new Point3d(0.0,0.0,0.0);
    dummyv2 = new Point3d(0.0,0.0,0.0);
    dummyv3 = new Point3d(0.0,0.0,0.0);
    dummyv4 = new Point3d(0.0,0.0,0.0);
    dummyQE = new Quadric();
    
    numE = 0;
    InitV();
    InitT();
    
    /*
    point = rpoint;
    boundary = rboundary;
    */
    initialV = new Vertices[deciV];
    NHead = new Neighbor[deciV];
    NTail = new Neighbor[deciV];
    
    NEHead = new NEList[deciV];
    NETail = new NEList[deciV];
    
    Vertices now = VHead;
    
    for(i=0;i<deciV;i++){
      AppendV(i);
      now = next(now);
      initialV[i] = now;
      NHead[i] = new Neighbor();
      NTail[i] = new Neighbor();
      NHead[i].next = NTail[i];
      NTail[i].back = NHead[i];
      
      NEHead[i] = new NEList();
      NETail[i] = new NEList();
      NEHead[i].next = NETail[i];
      NETail[i].back = NEHead[i];
    }
    
    for(i=0;i<deciF;i++){
      if(dFace[i][0]>dFace[i][1])numE++;
      if(dFace[i][1]>dFace[i][2])numE++;
      if(dFace[i][2]>dFace[i][0])numE++;
    }
    
    Root = new Edge[numE];
    pqueue = new PriorityQueue(numE);
    HeapPointerN = 0;
    System.out.println("Number of Edges: "+numE);
    Triangle nowt = THead;
    for(i=0;i<deciF;i++){
      AppendT(dFace[i][0],dFace[i][1],dFace[i][2]);
      nowt = next(nowt);
      AppendN(nowt,NTail[dFace[i][0]]);
      AppendN(nowt,NTail[dFace[i][1]]);
      AppendN(nowt,NTail[dFace[i][2]]);
    }
    
    double tarea=0.0;
    Neighbor nownt=null;
    for(i=0;i<deciV;i++){
      tarea=0.0;
      nownt = NHead[i];
      while(next(nownt)!=NTail[i]){
	nownt = next(nownt);
	tarea += nownt.dt.area;
      }
      initialV[i].error.normalizeQE(tarea);
    }    
    
    for(i=0;i<deciF;i++){
      if(dFace[i][0]>dFace[i][1])AppendE(initialV[dFace[i][0]],
					 initialV[dFace[i][1]]);
      if(dFace[i][1]>dFace[i][2])AppendE(initialV[dFace[i][1]],
					 initialV[dFace[i][2]]);
      if(dFace[i][2]>dFace[i][0])AppendE(initialV[dFace[i][2]],
					 initialV[dFace[i][0]]);
    }
    maxenergy = Math.abs(pqueue.getmax())-10.0;
  }
  
  public void getVFace(Point3d[] subpoint,int[][] subFace,IDList[] dFHead,
		       IDList[] dFTail,int[] dneighborF,int[] dindex){
    int i=0;
    IDList nowparam=null;
    Vertices now = VHead;
    while(next(now)!=VTail){
      now = next(now);
      if(now.EC){
	subpoint[i] = new Point3d(point[now.ID].x,
				  point[now.ID].y,
				  point[now.ID].z);
	dindex[i] = now.ID;
	nowparam = FHead[now.ID];
	dneighborF[i] = neighborF[now.ID];
	while(next(nowparam)!=FTail[now.ID]){
	  nowparam = next(nowparam);
	  AppendVF(nowparam.ID,dFTail[i]);
	}
	now.ID = i;
	i++;	  
      }
    }
    i = 0;
    Triangle nowt = THead;
    while(next(nowt)!=TTail){
      
      nowt = next(nowt);
      if(nowt.EC){
	//System.out.println("i:"+i);
	if(nowt.v1.ID<deciV && nowt.v2.ID<deciV && nowt.v3.ID<deciV){ 
	  subFace[i][0] = nowt.v1.ID;
	  subFace[i][1] = nowt.v2.ID;
	  subFace[i][2] = nowt.v3.ID;
	  i++;
	}
      }
    }
    pqueue=null;
  }
  private void RemoveNeighbor(Triangle dt,int di,int dj){
    Neighbor now=null;
    int dtarget=dt.getV(di,dj);
    if(dtarget==-1){
      System.out.println("Error !!!");
      
    }else{
      now = NHead[dtarget];
      while(next(now)!=NTail[dtarget]){
	now = next(now);
	if(!(now.dt.EC)){
	  Remove(now);
	  break;
	}
      }
      NEList nowNE = NEHead[dtarget];
      while(next(nowNE)!=NETail[dtarget]){
	nowNE = next(nowNE);
	if(nowNE.de.vp1.ID==di||
	   nowNE.de.vp2.ID==di){
	  Remove(nowNE);
	  break;
	}
      }
    }    
  }
  
  public int getNowVNum(){
    return deciV;
  }
  
  
  private int getTnum(){
    int num=0;
    Triangle now = THead;
    while(next(now)!=TTail){
      now = next(now);
      num++;
    }
    
    return num;
  }
  public void Decimation(int objnum){
    Point3d mynewp = new Point3d(0.0,0.0,0.0);
    
    numOK=0;
    numCANCEL=0;
    while(deciV>objnum){
      
      if(Update(mynewp))break;
      iterationnum++;
      if(iterationnum>=numE){
	break;
      }
    }
    
    System.out.println("OK = "+numOK);
    System.out.println("CANCEL = "+numCANCEL);
    int i=0;
     int realV=0;
     int realF=0;
     
     Vertices now = VHead;
     while(next(now)!=VTail){
       now = next(now);
       if(now.EC){
	 realV++;
       }
     }
     Triangle nowt = THead;
     while(next(nowt)!=TTail){
       
       nowt = next(nowt);
       if(nowt.EC){
	 realF++;
       }
     }
     deciV=realV;
     deciF=realF;
     
  }
  
  
  
  
  private boolean Update(Point3d dv){
    int mypop = pqueue.Pop();
    
    if(mypop==-1)return true;
    Edge now = Root[mypop];
    if(now==null)return true;
    //System.out.println(+now.ene);
    
    
    if(Consistency(now.vp1.ID,now.vp2.ID,dv)){
      EdgeCollapse(now.vp1.ID,now.vp2.ID,dv);
      
      numOK++;
    }else{
      pqueue.Put(mypop,realmax);
      numCANCEL++;
    }
    
    return false;
  }

  private double Size(Point3d dv){
    return Math.sqrt((dv.x*dv.x + dv.y*dv.y +dv.z*dv.z));
  }
  private double DistanceS(Point3d dv1,Point3d dv2){
    double dx = dv1.x - dv2.x;
    double dy = dv1.y - dv2.y;
    double dz = dv1.z - dv2.z;
    return (dx*dx+dy*dy+dz*dz);
  }
  private boolean SearchI(int dID,IDList dIHead,IDList dITail){
    
    IDList now = dIHead;
    while(next(now)!=dITail){
      now = next(now);
      if((now.ID==dID)){
	return true;
      }
    }
    return false;
  }
 
  public void AppendVF(int myID,IDList dVTail)
    {
      IDList now = new IDList(myID);
      
      IDList dummy = dVTail.back;
      now.next = dVTail;
      dVTail.back = now;
      now.back = dummy;
      dummy.next =now;
    } 
  private void AppendI(int dID,IDList dIHead,IDList dITail,int nowID,int[] dnum)
    {
      if(dID!=nowID){
	if(!SearchI(dID,dIHead,dITail)){
	  IDList now = new IDList(dID);
	  IDList dummy = dITail.back;
	  now.next = dITail;
	  dITail.back = now;
	  now.back = dummy;
	  dummy.next =now;
	  dnum[nowID]++;
	}
      }else{
	//System.out.println("Check !!!");
      }
    }
  
  private void EdgeCollapse(int i,int j,Point3d dv){
    
    
    Neighbor now;
    Neighbor tmp;
    NEList nowe;
    point[j].x = dv.x;
    point[j].y = dv.y;
    point[j].z = dv.z;
    if(boundary[i]==1)boundary[j]=1;
    

    IDList nowparam = FHead[i];
    while(next(nowparam)!=FTail[i]){
      nowparam = next(nowparam);
      AppendI(nowparam.ID,FHead[j],FTail[j],j,neighborF);    
    }


    initialV[j].error.addQE(initialV[i].error);
    
    
    /* 
       If T_{i} has two vertices (di and dj) then it neighbor 
       triangle is removed, and T_{i} real take EC = false. 
       */
    
    initialV[i].EC = false;
    now = NHead[j];
    while(next(now)!=NTail[j]){
      now = next(now);
      if(now.dt.HasTwoV(i,j)){
	now.dt.EC = false;
	deciF--;
	RemoveNeighbor((now.dt),i,j);
	tmp = back(now);
	Remove(now);
	now = tmp;
      }    
    }
      
    
    /* If T_{i} take EC = true then T_{around} is inserted to 
       vertex (dj) neighbor, and index di of T_{i} is changed to index dj. */
    
    now = NHead[i];
    while(next(now)!=NTail[i]){
      now = next(now);
      if(now.dt.EC){
	now.dt.changeItoJ(initialV[i],initialV[j]);
	AppendN((now.dt),NTail[j]);
      }
    }
    
    
    
    
    /* Remove and Add Neighbor Edges of T_{i} to T_{j} */
    
    nowe = NEHead[j];
    while(next(nowe)!=NETail[j]){
      nowe = next(nowe);
      if(nowe.de.vp1.ID == i||
	 nowe.de.vp2.ID == i){
	Remove(nowe);
	break;
      }
    }    

    nowe = NEHead[i];
    while(next(nowe)!=NETail[i]){
      nowe = next(nowe);
      //System.out.println(+nowe.de.vp1.ID+" "+nowe.de.vp2.ID);
      if(nowe.getV(i) != j){
	
	if(nowe.de.vp1==initialV[i]){
	  nowe.de.vp1 = initialV[j];
	}else if(nowe.de.vp2==initialV[i]){
	  nowe.de.vp2 = initialV[j];
	}
	AppendNE(nowe.de,NEHead[j],NETail[j]);
      }else{
	nowe.de.EC=false;
      }
    }
    
         
   /* Update HeapData */
   
   
   
   int dtarget;
   nowe = NEHead[j];
   while(next(nowe)!=NETail[j]){
     nowe = next(nowe);
     dtarget = nowe.getV(j);     
     pqueue.HeapUpdate(nowe.de.idx,getEnergy(j,dtarget));
   }

   deciV--;
   
  }


  private void CrossVector(Point3d out,Point3d in1,Point3d in2){
    out.x = (in1.y*in2.z - in2.y*in1.z);
    out.y = (in1.z*in2.x - in2.z*in1.x);
    out.z = (in1.x*in2.y - in2.x*in1.y);
  }
  private void setNormal(Point3d dln,int i,int j,Point3d newp,Point3d dv1,Point3d dv2){
    
      dv1.x = (point[i].x-newp.x);
      dv1.y = (point[i].y-newp.y);
      dv1.z = (point[i].z-newp.z);
      dv2.x = (point[j].x-newp.x);
      dv2.y = (point[j].y-newp.y);
      dv2.z = (point[j].z-newp.z);
    CrossVector(dln,dv1,dv2);
  }
  
  private boolean WillBeNonManifold(int i,int j){
    int num2i=0;
    int num2j=0;
    int numFi=0;
    int numFj=0;
    
    Neighbor now = NHead[i];
    while(next(now)!=NTail[i]){
      now = next(now);
      if(now.dt.HasTwoV(i,j))num2i++;
      numFi++;
    }
    if(num2i>=2)return true;
    now = NHead[j];
    while(next(now)!=NTail[j]){
      now = next(now);
      if(now.dt.HasTwoV(i,j))num2j++;
      numFj++;
    }
    if(num2j>=2)return true;
    
    int numVi=0;
    int numVj=0;
    
    NEList nowe = NEHead[i];
    while(next(nowe)!=NETail[i]){
      nowe = next(nowe);
      numVi++;
    }
    nowe = NEHead[j];
    while(next(nowe)!=NETail[j]){
      nowe = next(nowe);
      numVj++;
    }
    int numFnew =  (numFi+numFj-num2i-num2j);
    int numEnew =  (numVi+numVj -(num2i+num2j)/2 - 2);


    

    if(numFnew>=(numEnew - 1)){
      return false;
    }else{
      return true;
    }
  }
 
  private boolean Consistency(int i,int j,Point3d dv){
    //if(boundary[i]==1||boundary[j]==1)return false;
    //if(boundary[i]==1&&boundary[j]==1)return false;
    /* special rule for displaced subdivision surface */
    int numVi=0;
    int numVj=0;
    
    NEList nowe = NEHead[i];
    while(next(nowe)!=NETail[i]){
      nowe = next(nowe);
      numVi++;
    }
    nowe = NEHead[j];
    while(next(nowe)!=NETail[j]){
      nowe = next(nowe);
      numVj++;
    }
    /*
    if(restriction<= (numVi+numVj-4)){
      return false;
    }
    */
    if(boundary[i]==1&&boundary[j]==1)
      if(WillBeNonManifold(i,j))return false;
    
    
    setNewPosition(i,j,dv);
    
    //System.out.println(+dv.x+" "+dv.y+" "+dv.z);
    int dk1,dk2;
    
    dummyv4.x = 0.0;
    dummyv4.y = 0.0;
    dummyv4.z = 0.0;
    
    double dsize=0.0;
    
    double Gamma=0.0;
    
    Neighbor now = NHead[i];
    while(next(now)!=NTail[i]){
      now = next(now);
      
      if(!(now.dt.HasTwoV(i,j))){
	dk1 = now.dt.getV1(i);
	dk2 = now.dt.getV2(i);
	//System.out.println("i :"+i+" j: "+j+" dk1: "+dk1+" dk2: "+dk2);
	if(dk1==-1||dk2==-1){
	  //System.out.println("i :"+i+" j: "+j);
	  //System.out.println(+now.dt.v1.ID+" "+now.dt.v2.ID+" "+now.dt.v3.ID);
	  if(now.dt.EC){
	    //System.out.println("TRUE");
	   
	  }else{
	    //System.out.println("FALSE");
	    }
	  return false;
	}
	
	setNormal(dummyv3,dk1,dk2,dv,dummyv1,dummyv2);
	dummyv4.x += dummyv3.x;
	dummyv4.y += dummyv3.y;
	dummyv4.z += dummyv3.z;
	Gamma = ((2.0*Math.sqrt(3.0)*Size(dummyv3))/
		 (DistanceS(dv,point[dk1])+DistanceS(dv,point[dk2])
		  +DistanceS(point[dk1],point[dk2])));
	//if(Gamma<0.1)System.out.println(+i+" "+j+" :"+Gamma);
	if(Gamma<=ThresholdGamma){
	  return false;
	}
      }
    }
    
    now = NHead[j];
    while(next(now)!=NTail[j]){
      now = next(now);
      
      if(!(now.dt.HasTwoV(i,j))){
	dk1 = now.dt.getV1(j);
	dk2 = now.dt.getV2(j);
	if(dk1==-1||dk2==-1){
	  // System.out.println("i :"+i+" j: "+j);
	  //System.out.println(+now.dt.v1.ID+" "+now.dt.v2.ID+" "+now.dt.v3.ID);
	  if(now.dt.EC){
	    //System.out.println("TRUE");
	    
	  }else{
	    //System.out.println("FALSE");
	    }
	  return false;
	}
	
	setNormal(dummyv3,dk1,dk2,dv,dummyv1,dummyv2);
	dummyv4.x += dummyv3.x;
	dummyv4.y += dummyv3.y;
	dummyv4.z += dummyv3.z;
	Gamma = ((2.0*Math.sqrt(3.0)*Size(dummyv3))/
		 (DistanceS(dv,point[dk1])+DistanceS(dv,point[dk2])
		  +DistanceS(point[dk1],point[dk2])));
	if(Gamma<=ThresholdGamma){
	  return false;
	}
      }
    }
    dsize = Size(dummyv4);
    if(dsize==0.0)dsize=1.0;
    dummyv4.x /= dsize;
    dummyv4.y /= dsize;
    dummyv4.z /= dsize;
    
    
    now = NHead[i];
    while(next(now)!=NTail[i]){
      now = next(now);
      
      if(!(now.dt.HasTwoV(i,j))){
	dk1 = now.dt.getV1(i);
	dk2 = now.dt.getV2(i);
	dummyv1.x = 0.5*(point[dk1].x+point[dk2].x)+dummyv4.x;
	dummyv1.y = 0.5*(point[dk1].y+point[dk2].y)+dummyv4.y;
	dummyv1.z = 0.5*(point[dk1].z+point[dk2].z)+dummyv4.z;
	if(PlaneSize(point[dk1],point[dk2],dummyv1,dv))return false;
      }
    }
    now = NHead[j];
    while(next(now)!=NTail[j]){
      now = next(now);
      
      if(!(now.dt.HasTwoV(i,j))){
	dk1 = now.dt.getV1(j);
	dk2 = now.dt.getV2(j);
	dummyv1.x = 0.5*(point[dk1].x+point[dk2].x)+dummyv4.x;
	dummyv1.y = 0.5*(point[dk1].y+point[dk2].y)+dummyv4.y;
	dummyv1.z = 0.5*(point[dk1].z+point[dk2].z)+dummyv4.z;
	if(PlaneSize(point[dk1],point[dk2],dummyv1,dv))return false;
      }
    }
    

    return true;
  }
  private boolean PlaneSize(Point3d p1,Point3d p2,Point3d p3,Point3d ep){
   double dv = (-ep.z*p1.y*p2.x + ep.y*p1.z*p2.x + ep.z*p1.x*p2.y - 
		ep.x*p1.z*p2.y - ep.y*p1.x*p2.z + ep.x*p1.y*p2.z + 
		ep.z*p1.y*p3.x - ep.y*p1.z*p3.x - ep.z*p2.y*p3.x + 
		p1.z*p2.y*p3.x + ep.y*p2.z*p3.x - p1.y*p2.z*p3.x - 
		ep.z*p1.x*p3.y + ep.x*p1.z*p3.y + ep.z*p2.x*p3.y - 
		p1.z*p2.x*p3.y - ep.x*p2.z*p3.y + p1.x*p2.z*p3.y + 
		ep.y*p1.x*p3.z - ep.x*p1.y*p3.z - ep.y*p2.x*p3.z + 
		p1.y*p2.x*p3.z + ep.x*p2.y*p3.z - p1.x*p2.y*p3.z);
   
   //System.out.println(+dv);
   if(dv>0.0)return true;
   return false;
  }
    
  private void setNewPosition(int i,int j,Point3d dv){
    int dk1=0;
    int dk2=0;
    double totaltmp = 0.0;
    
    if(boundary[i]==1&&boundary[j]==1){
      dv.x = 0.5*(point[i].x + point[j].x);
      dv.y = 0.5*(point[i].y + point[j].y);
      dv.z = 0.5*(point[i].z + point[j].z);
    }else if(boundary[i]==1&&boundary[j]!=1){
      dv.x = point[i].x;
      dv.y = point[i].y;
      dv.z = point[i].z;
      
    }else if(boundary[i]!=1&&boundary[j]==1){
      dv.x = point[j].x;
      dv.y = point[j].y;
      dv.z = point[j].z;
    }else{
      dummyQE.UpdateQuadric(initialV[i].error,initialV[j].error);
      if(!dummyQE.setNewPosition(dv)){
	//System.out.println("Error !!!");
	dv.x = 0.5*(point[i].x + point[j].x);
	dv.y = 0.5*(point[i].y + point[j].y);
	dv.z = 0.5*(point[i].z + point[j].z);
      }
    }
  }
  
  
  private void InitV(){
    VHead = new Vertices();
    VTail = new Vertices();
    VHead.next = VTail;
    VTail.back = VHead;
  }
  private void InitT(){
     THead = new Triangle();
    TTail = new Triangle();
    THead.next = TTail;
    TTail.back = THead;
  }
    
  private void AppendV(int dv){
    Vertices tmp = new Vertices(dv);
    Vertices tmp2 = VTail.back;
    tmp.back = tmp2;
    tmp2.next = tmp;
    tmp.next = VTail;
    VTail.back = tmp;
  }
  private double getSize(Point3d dv){
    return Math.sqrt((dv.x*dv.x + dv.y*dv.y + dv.z*dv.z));
  }
   
   private double getEnergy(Vertices dv1,Vertices dv2){
    double energy;
    dummyQE.UpdateQuadric(dv1.error,dv2.error);
    if(!dummyQE.setNewPosition(dummyv1)){
      //System.out.println("AAAA");
      dummyv1.x = (point[dv1.ID].x + point[dv2.ID].x)/2.0;
      dummyv1.y = (point[dv1.ID].y + point[dv2.ID].y)/2.0;
      dummyv1.z = (point[dv1.ID].z + point[dv2.ID].z)/2.0;
    }
   
    energy = dummyQE.Quadric(dummyv1);
    if(maxenergy>energy)maxenergy = energy-10.0;
    if(realmax<energy)realmax = energy+10.0;
    return energy;
  }
  private double getEnergy(int i,int j){
    double energy;
    Vertices dv1 = initialV[i];
    Vertices dv2 = initialV[j];
    dummyQE.UpdateQuadric(dv1.error,dv2.error);
    if(!dummyQE.setNewPosition(dummyv1)){
      dummyv1.x = (point[dv1.ID].x + point[dv2.ID].x)/2.0;
      dummyv1.y = (point[dv1.ID].y + point[dv2.ID].y)/2.0;
      dummyv1.z = (point[dv1.ID].z + point[dv2.ID].z)/2.0;
    }
    energy = dummyQE.Quadric(dummyv1);
    if(maxenergy>energy)maxenergy = energy-10.0;
    if(realmax<energy)realmax = energy+10.0;
    return energy;
  }
  

  private void AppendE(Vertices dv1,Vertices dv2){
    Edge tmp = new Edge(dv1,dv2);
    tmp.ene = getEnergy(dv1,dv2);
    tmp.idx = HeapPointerN;
    Root[HeapPointerN] = tmp;
    pqueue.Put(HeapPointerN,tmp.ene);
    HeapPointerN++;
    AppendNE(tmp,NETail[dv1.ID]);
    AppendNE(tmp,NETail[dv2.ID]); 
  }
  
  
   private void AppendNE(Edge dv,NEList dTail){
     NEList tmp = new NEList(dv);
     NEList tmp2 = dTail.back;
     tmp.back = tmp2;
     tmp2.next = tmp;
     tmp.next = dTail;
     dTail.back = tmp;
  }
 
  
   private void AppendNE(Edge dv,NEList dHead,NEList dTail){
     NEList now = dHead;
     boolean mycheck=true;
     
     while(next(now)!=dTail){
       now = next(now);
       if(((now.de.vp1==dv.vp1)&&(now.de.vp2==dv.vp2))||
	  ((now.de.vp1==dv.vp2)&&(now.de.vp2==dv.vp1))){
	 mycheck = false;
	 double mymy = Root[dv.idx].ene;
	 pqueue.HeapUpdate(dv.idx,maxenergy);
	 int mymymy = pqueue.Pop();
	 Edge dddd = Root[mymymy];
	 
	 if(dddd.idx!=dv.idx){
	   System.out.println("dv.id = "+dv.idx+" dddd.idx = "+
			      dddd.idx+" mymymy = "+mymymy+
			      " Old(dv).w = "+mymy);
	   System.out.println("maxenergy = "+maxenergy+" dddd.w = "+dddd.ene);
	   System.out.println("AAAAAAAAAAAAAAAAAAAAAAAAAA");
	   System.out.println("get: "+dddd.vp1.ID+" "+dddd.vp2.ID);
	   //System.exit(0);
	 }
	 break;
       }
     }
     if(mycheck)AppendNE(dv,dTail);
   }
  
  

  private void AppendN(Triangle dv,Neighbor dTail){
    Neighbor tmp = new Neighbor(dv);
    Neighbor tmp2 = dTail.back;
    tmp.back = tmp2;
    tmp2.next = tmp;
    tmp.next = dTail;
    dTail.back = tmp;
  }
  private void setTNormal(int dv1,int dv2,int dv3){
    dummyv1.x = (point[dv2].x-point[dv1].x);
    dummyv1.y = (point[dv2].y-point[dv1].y);
    dummyv1.z = (point[dv2].z-point[dv1].z);
    dummyv2.x = (point[dv3].x-point[dv1].x);
    dummyv2.y = (point[dv3].y-point[dv1].y);
    dummyv2.z = (point[dv3].z-point[dv1].z);
    CrossVector(dummyv3,dummyv1,dummyv2);
  }
  private void AppendT(int dv1,int dv2,int dv3){
    Triangle tmp = new Triangle(initialV[dv1],initialV[dv2],initialV[dv3]);
    setTNormal(dv1,dv2,dv3);
    tmp.setABCD(point[dv1],dummyv3);
    Triangle tmp2 = TTail.back;
    tmp.back = tmp2;
    tmp2.next = tmp;
    tmp.next = TTail;
    TTail.back = tmp;
  }
  
  private void Remove(Neighbor dv){
    Neighbor tmp1 = dv.back;
    Neighbor tmp2 = dv.next;
    tmp2.back = tmp1;
    tmp1.next = tmp2;
  }
  private void Remove(NEList dv){
    NEList tmp1 = dv.back;
    NEList tmp2 = dv.next;
    tmp2.back = tmp1;
    tmp1.next = tmp2;
  }
  
  private IDList next(IDList now)
    {
      return (now.next);
    }
  private IDList back(IDList now)
    {
      return (now.back);
    }   
  private Vertices next(Vertices now)
    {
      return (now.next);
    }
  private Vertices back(Vertices now)
    {
      return (now.back);
    } 
  private Triangle next(Triangle now)
    {
      return (now.next);
    }
  private Triangle back(Triangle now)
    {
      return (now.back);
    } 
  private Neighbor next(Neighbor now)
    {
      return (now.next);
    }
  private Neighbor back(Neighbor now)
    {
      return (now.back);
    }  
  private Edge next(Edge now)
    {
      return (now.next);
    }
  private Edge back(Edge now)
    {
      return (now.back);
    }  
  
  private NEList next(NEList now)
    {
      return (now.next);
    }
  private NEList back(NEList now)
    {
      return (now.back);
    }
  class NEList implements java.io.Serializable{
    Edge de=null;
    NEList next=null;
    NEList back=null;
    public NEList(){
    }
    public NEList(Edge dv){
      de = dv;
    }
    public int getV(int i){
      if(de.vp1.ID==i){
	return de.vp2.ID;
      }else if(de.vp2.ID==i){
	return de.vp1.ID;
      }else{
	return -1;
      }
    }
  }
  class Vertices{
    
    Vertices next=null;
    Vertices back=null;
    int ID=-1;
    boolean EC=false;
    Quadric error=null;
    public Vertices(){
      ID = -1;
      EC=false;
      error = new Quadric();
    }
    public Vertices(int dv){
      ID = dv;
      EC=true;
      error = new Quadric();
    }
    public void addABCD(Quadric dv){
      error.addQE(dv);
    }
    public double Quadric(Point3d dv){
      return error.Quadric(dv);
    }
  }
  class Triangle{
    
    
    Triangle next=null;
    Triangle back=null;
    boolean EC=false;
    Vertices v1=null;
    Vertices v2=null;
    Vertices v3=null;
    
    Quadric error=null;
    double area=0.0;
    public Triangle(){
      v1=null;
      EC=false;
      v2=null;
      v3=null;
    }
    public Triangle(Vertices dv1,Vertices dv2,Vertices dv3){
      v1 = dv1;EC=true;
      v2 = dv2;
      v3 = dv3;
    }
    public void setABCD(Point3d dv1,Point3d dn){
      double size = Math.sqrt((dn.x*dn.x + dn.y*dn.y + dn.z*dn.z));
      if(size==0.0)size = 1.0;
      double dx = (dn.x/size);
      double dy = (dn.y/size);
      double dz = (dn.z/size);
      area = (size/2.0);
      error = new Quadric(dx,dy,dz,(-(dv1.x*dx+dv1.y*dy+dv1.z*dz)),(size/2.0));
      
      v1.addABCD(error);
      v2.addABCD(error);
      v3.addABCD(error);
      
    }
    
    public boolean HasTwoV(int di,int dj){
      if((v1.ID==di&&v2.ID==dj)||
	 (v1.ID==dj&&v2.ID==di)||
	 (v1.ID==di&&v3.ID==dj)||
	 (v1.ID==dj&&v3.ID==di)||
	 (v2.ID==di&&v3.ID==dj)||
	 (v2.ID==dj&&v3.ID==di)){      
	return true;
      }else{
	return false;
      }
    }
    public int getV(int di,int dj){
      if((v1.ID==di&&v2.ID==dj)||
	 (v1.ID==dj&&v2.ID==di)){
	return v3.ID;
      }else if((v1.ID==di&&v3.ID==dj)||
	       (v1.ID==dj&&v3.ID==di)){
	return v2.ID;
      }else if((v2.ID==di&&v3.ID==dj)||
	       (v2.ID==dj&&v3.ID==di)){      
	return v1.ID;
      }else{
	return -1;
      }
    }
    public int getV1(int di){
      if(v1.ID==di){
	return v2.ID;
      }else if(v2.ID==di){
	return v3.ID;
      }else if(v3.ID==di){
	return v1.ID;
      }else{
	return -1;
      }
    }
    public int getV2(int di){
      if(v1.ID==di){
	return v3.ID;
      }else if(v2.ID==di){
	return v1.ID;
      }else if(v3.ID==di){
	return v2.ID;
      }else{
	return -1;
      }
    }
    
    
    
    public void changeItoJ(Vertices dv1,Vertices dv2){
      if(v1==dv1){
	v1 = dv2;
      }else if(v2==dv1){
	v2 = dv2;
      }else if(v3==dv1){
	v3 = dv2;
      }else{
	
	System.out.println("Error 2 !!!!");
      }
    }
  }
class Quadric{
  double bx = 0.0;
  double by = 0.0;
  double bz = 0.0;
  double dd=0.0;
  double a11,a12,a13,a22,a23,a33;
  
  public Quadric(){
    bx = 0.0;by=0.0;bz =0.0;dd=0.0;
    a11 = 0.0;a12 = 0.0;a13 = 0.0;a22 = 0.0;a23 = 0.0;a33 = 0.0;
  }
  
  public Quadric(double dva,double dvb,double dvc,double dvd,double weight){
    //weight = 1.0;
    bx = weight*dvd*dva;
    by = weight*dvd*dvb;
    bz = weight*dvd*dvc;
    dd = weight*dvd*dvd;
    a11 = weight*dva*dva; a12 = weight*dva*dvb; a13 = weight*dva*dvc;
    a22 = weight*dvb*dvb; a23 = weight*dvb*dvc;
    a33 = weight*dvc*dvc;
  }
  public boolean setNewPosition(Point3d dv){
    double dx,dy,dz;
    double divisor = (-a13*a13*a22 + 2.0*a12*a13*a23 - a11*a23*a23 - a12*a12*a33 + a11*a22*a33);
    //System.out.println("divisor: "+divisor);
    //if(Math.abs(divisor)<=0.0000001)return false;   
    if(Math.abs(divisor)<=0.000000000001)return false;   
    
    dx = -((-a23*a23 + a22*a33)*bx+(a13*a23 - a12*a33)*by
	  +(-a13*a22 + a12*a23)*bz)/divisor;
    dy = -((a13*a23 - a12*a33)*bx+(-a13*a13 + a11*a33)*by
	  +(a12*a13 - a11*a23)*bz)/divisor;
    dz = -((-a13*a22 + a12*a23)*bx+(a12*a13 - a11*a23)*by
	  +(-a12*a12 + a11*a22)*bz)/divisor;
    dv.x = dx;
    dv.y = dy;
    dv.z = dz;
    return true;
  }
  public void normalizeQE(double dv){
    bx /= dv;
    by /= dv;
    bz /= dv;
    dd /= dv;
    a11 /= dv;
    a12 /= dv;
    a13 /= dv;
    a22 /= dv;
    a23 /= dv;
    a33 /= dv;
  
  }
  public void UpdateQuadric(Quadric dv1,Quadric dv2){
    bx = dv1.bx + dv2.bx;
    by = dv1.by + dv2.by;
    bz = dv1.bz + dv2.bz;
    dd = dv1.dd + dv2.dd;
    a11 = dv1.a11 + dv2.a11; 
    a12 = dv1.a12 + dv2.a12; 
    a13 = dv1.a13 + dv2.a13;
    a22 = dv1.a22 + dv2.a22;
    a23 = dv1.a23 + dv2.a23;
    a33 = dv1.a33 + dv2.a33;
  }
  
  
  public void addQE(Quadric dv){
    bx += dv.bx;
    by += dv.by;
    bz += dv.bz;
    dd += dv.dd;
    a11 += dv.a11; a12 += dv.a12; a13 += dv.a13;
    a22 += dv.a22; a23 += dv.a23; a33 += dv.a33;
  }
  
  public double Quadric(Point3d dv){
    return (dd + 2.0*bx*dv.x + a11*dv.x*dv.x + 2.0*by*dv.y + 2.0*a12*dv.x*dv.y + 
     a22*dv.y*dv.y + 2.0*bz*dv.z + 2.0*a13*dv.x*dv.z + 2.0*a23*dv.y*dv.z + a33*dv.z*dv.z);
  }
  

}
class PriorityQueue{
  HeapNode[] hlist=null;
  int[] hindex=null;
  int nodeN=0;
  int hpointerM=0;
  
  class HeapNode{
    double weight=0.0;
    int idx=-1;
    public HeapNode(){
    }
  
    public HeapNode(int dv,double dw){
      idx = dv;
      weight = dw;
    }
  }

  
  public PriorityQueue(int dv){
    nodeN = dv;
    hlist = new HeapNode[nodeN];
    hindex = new int[nodeN];
    for(int i=0;i<nodeN;i++){
      hindex[i] = 0;
    }
  }
  public double getmax(){
    return hlist[0].weight;
  }
 private void swap(int i, int j) {
   HeapNode t;
   t = hlist[i];  
   hlist[i] = hlist[j];  
   hlist[j] = t;
   hindex[hlist[i].idx] = i;
   hindex[hlist[j].idx] = j;
 }
 
                            
 private void upheap(int i){
   int j;
   while (i != 0) {
     j = (((i)-1)/2);
     if (hlist[i].weight >= hlist[j].weight)
       break;
     swap(i,j);
     i = j;
   }
 }
 private void downheap(int i) {
   int j;
   while ((j = ((i)*2+1)) < hpointerM) {
     if(j+1 < hpointerM && hlist[j+1].weight < hlist[j].weight)
       j ++;
     if(hlist[j].weight >= hlist[i].weight)break;
     swap(i, j);
     i = j;
   }
 }
 
 public void Put(int idx, double w) {
   hlist[hpointerM] = new HeapNode(idx,w);
   hindex[idx] = hpointerM;
   hpointerM ++;
   upheap((hpointerM-1));
 }
 private HeapNode get(){
   HeapNode dv = hlist[0];
   hpointerM--;
   if(hpointerM<0)return null;
   hlist[0] = hlist[hpointerM];
   hindex[hlist[0].idx] = 0;
   downheap(0);
   return dv;
 }
 public void HeapUpdate(int idx, double w) {
   int i;  double oldv;
   i = hindex[idx];
   oldv = hlist[i].weight;
   hlist[i].weight = w;
   if(w < oldv){
     upheap(i);
   }else{
     downheap(i);
   }
 }
  public int Pop(){
    HeapNode tmp = this.get();
    if(tmp==null)return -1;
    return tmp.idx;
  }
}
  class Edge{
    Vertices vp1=null;
    Vertices vp2=null;
    double ene=0.0;
    int idx=-1;
    boolean EC=true;
    Edge next=null;
    Edge back=null;
    public Edge(){
    vp1 = null;
    vp2 = null;
    ene = 0.0;
    }
    
    public Edge(Vertices dv1,Vertices dv2){
      vp1 = dv1;
      vp2 = dv2;
      ene = 0.0;
    }
    public Edge(Vertices dv1,Vertices dv2,double dene){
      vp1 = dv1;
      vp2 = dv2;
      ene = dene;
    }
    
}
  class Neighbor{
    Neighbor next=null;
    Neighbor back=null;
    Triangle dt=null;
    public Neighbor(Triangle dv){
      dt = dv;
      
    }
    public Neighbor(){
      dt=null;
    }
  }
  
  
}
