import java.awt.*;
import java.applet.*;
import java.util.*;
import java.lang.*;
import java.awt.event.*;
import java.io.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class TriangleMesh{
   double maxX=0.0;
  double maxY=0.0;
  double maxZ=0.0;
  double minX=0.0;
  double minY=0.0;
  double minZ=0.0;
  
  ViewShape3D myobj=null;
  
    boolean dipli=false;
  Point3d[] point = null;
  
  
  Point3d[] mynormal=null;
  Vector3f[] mynormalnormal=null;
  double aveH;
  double sdviH;
  double[] H=null;
  
  double minarea=1000.0;
  double threshold=1.5;
  int[] index=null;
  Point3d[] laplace=null;
    
  Point3d[] bilaplace=null;
  Point3d[] KnotInit=null;
  
  int numberV=0;
  int numberF=0;
  int numberE=0;
  int EulerC=0;
  double scaler =1.0;

  /* true is original, false is skeleton */
  IDList BEHead=null;
  IDList BETail=null;
  int[][] Face;
  int[] neighborI=null;
  int[] neighborF=null;
  int[] neighborV=null;
  IDList[] FHead=null;
  IDList[] FTail=null;
  IDList[] VHead=null;
  IDList[] VTail=null;
  IDList[] IHead=null;
  IDList[] ITail=null;
  int[] boundary=null;
  int numboundary=0;
  /* Subdivide Attribute */
  Point3d[] subpoint=null;
  int[][] subFace=null;
  /* GH-Decimation Attribute */
  LineArray normalarray=null;
    
  GHDMesh mydecimate=null;


   Point3d tmppoint3d1 = new Point3d(0.0,0.0,0.0);
  Point3d tmppoint3d2 = new Point3d(0.0,0.0,0.0);
  Point3d Wvex= new Point3d(0.0,0.0,0.0);
  public TriangleMesh(){
  
  }

    
  private int getMinimumDistance(int dv){
    int i;
    int minid=-1;
    double mindist=0.0;
    double dummin=0.0;
    
    boolean firstcheck=true;
    for(i=0;i<numberV;i++){
      if(i!=dv){
	if(firstcheck){
	  firstcheck=false;
	  minid=i;
	  mindist = Distance(point[i],point[dv]);
	}else{
	  dummin = Distance(point[i],point[dv]);
	  if(mindist>dummin){
	    minid=i;
	    mindist = dummin;
	  }
	}
      }
    }
    return minid;
  }
  private int setclass(int dID){
    int minid=-1;
    
    minid = getMinimumDistance(dID);
    if(minid==-1){
      return -1;
    }
    IDList now = IHead[dID];
    while(next(now)!=ITail[dID]){
      now = next(now);
      if(now.ID==minid){
	return 2;
      }
    }
    return 0;
  }
  public void ReScale(double dv){
    scaler = dv;
  
  }
  public void setEdgeN(){
    int i=0;
    numberE = 0;
    for(i=0;i<numberV;i++){
      numberE += (neighborI[i]);
    }
    numberE /= 2;
    EulerC = numberV - numberE + numberF;
    System.out.println("V = "+numberV+", F = "+numberF+", E = "+numberE);
    System.out.println("EulerC = "+EulerC);
    
  }
  public void InitializeData(int di,double dx,double dy,double dz){
    index[di] = di;
    point[di] = new Point3d(dx,dy,dz);
    
    
    laplace[di] = new Point3d(0.0,0.0,0.0);
    bilaplace[di]= new Point3d(0.0,0.0,0.0);
    mynormal[(2*di)] = new Point3d(0.0,0.0,0.0);
	mynormal[(2*di+1)] = new Point3d(0.0,0.0,0.0);
	mynormalnormal[(2*di)] = new Vector3f(0.0f,0.0f,0.0f);
	mynormalnormal[(2*di+1)] = new Vector3f(0.0f,0.0f,0.0f);
    
    H[di] = 0.0;
    
    neighborV[di]=0;
    neighborF[di]=0;
    neighborI[di]=0;
    VHead[di] = new IDList();
    VTail[di]  = new IDList();
    this.Init(VHead[di],VTail[di]);
    FHead[di] = new IDList();
    FTail[di]  = new IDList();
    this.Init(FHead[di],FTail[di]);
    IHead[di] = new IDList();
    ITail[di]  = new IDList();
    this.Init(IHead[di],ITail[di]);
    KnotInit[di] = new Point3d(dx,dy,dz);	
   
  }
  public void InitializeData(int di,double dx,double dy,double dz,double dsp){
    index[di] = di;
    point[di] = new Point3d(dx,dy,dz);
        
    laplace[di] = new Point3d(0.0,0.0,0.0);
    bilaplace[di]= new Point3d(0.0,0.0,0.0);
    mynormal[(2*di)] = new Point3d(0.0,0.0,0.0);
	mynormal[(2*di+1)] = new Point3d(0.0,0.0,0.0);
	mynormalnormal[(2*di)] = new Vector3f(0.0f,0.0f,0.0f);
	mynormalnormal[(2*di+1)] = new Vector3f(0.0f,0.0f,0.0f);
    
    H[di] = 0.0;    
    neighborV[di]=0;
    neighborF[di]=0;
    neighborI[di]=0;
    VHead[di] = new IDList();
    VTail[di]  = new IDList();
    this.Init(VHead[di],VTail[di]);
    FHead[di] = new IDList();
    FTail[di]  = new IDList();
    this.Init(FHead[di],FTail[di]);
    IHead[di] = new IDList();
    ITail[di]  = new IDList();
    this.Init(IHead[di],ITail[di]);
    KnotInit[di] = new Point3d(dx,dy,dz);	
    
  }
  
  public void memoryallocation(int dnumberV,int dnumberF){
    numberV = dnumberV;
    numberF = dnumberF;
    
index  = new int[numberV];
    point = new Point3d[numberV];
    mynormal = new Point3d[(2*numberV)];
    mynormalnormal = new Vector3f[(numberV*2)];
    
    H = new double[numberV];
    
    
    boundary = new int[numberV];
    neighborV = new int[numberV];
    neighborF  = new int[numberV];
    neighborI = new int[numberV];
    VHead = new IDList[numberV];
    VTail = new IDList[numberV];
    FHead = new IDList[numberV];
    FTail = new IDList[numberV];
    IHead = new IDList[numberV];
    ITail = new IDList[numberV];
    KnotInit = new Point3d[numberV];
    
    laplace= new Point3d[numberV];
    bilaplace= new Point3d[numberV];
    Face = new int[numberF][3];
  }
   public void Init(IDList h,IDList t)
    {
      h.next = new IDList();
      t.back = new IDList();
      h.next = t;
      t.back = h;
    }
   public IDList next(IDList now)
    {
      return (now.next);
    }
  public IDList back(IDList now)
    {
      return (now.back);
    }
  
  public void AppendVF(int myID,IDList dVTail)
    {
      IDList now = new IDList(myID);
      
      IDList dummy = dVTail.back;
      now.next = dVTail;
      dVTail.back = now;
      now.back = dummy;
      dummy.next =now;
    } 
  private boolean SearchI(int dID,IDList dIHead,IDList dITail){
    
    IDList now = dIHead;
    while(next(now)!=dITail){
      now = next(now);
      if((now.ID==dID)){
	return true;
      }
    }
    return false;
  }
 
  
  public void AppendI(int dID,IDList dIHead,IDList dITail,int nowID,int[] dnum)
    {
      if(dID!=nowID){
	if(!SearchI(dID,dIHead,dITail)){
	  IDList now = new IDList(dID);
	  IDList dummy = dITail.back;
	  now.next = dITail;
	  dITail.back = now;
	  now.back = dummy;
	  dummy.next =now;
	  dnum[nowID]++;
	}
      }else{
	//System.out.println("Check !!!");
      }
    }
  public void MakeFace(int i,int di,int dj,int dk){
    Face[i][0] = di;
    Face[i][1] = dj;
    Face[i][2] = dk;
    /* One */
    this.AppendVF(i,FTail[di]);neighborF[di]++;
    this.AppendI(dj,IHead[di],ITail[di],di,neighborI);
    this.AppendI(dk,IHead[di],ITail[di],di,neighborI);
    this.AppendVF(dj,VTail[di]);neighborV[di]++;
    this.AppendVF(dk,VTail[di]);neighborV[di]++;
    /* Two */
    this.AppendVF(i,FTail[dj]);neighborF[dj]++;
    this.AppendI(di,IHead[dj],ITail[dj],dj,neighborI);
    this.AppendI(dk,IHead[dj],ITail[dj],dj,neighborI);
    this.AppendVF(dk,VTail[dj]);neighborV[dj]++;
    this.AppendVF(di,VTail[dj]);neighborV[dj]++;
    /* Three */
    this.AppendVF(i,FTail[dk]);neighborF[dk]++;
    this.AppendI(di,IHead[dk],ITail[dk],dk,neighborI);
    this.AppendI(dj,IHead[dk],ITail[dk],dk,neighborI);
    this.AppendVF(di,VTail[dk]);neighborV[dk]++;
    this.AppendVF(dj,VTail[dk]);neighborV[dk]++;
    
  }
   public void SetBoundaryLines(){
    int i=0;numboundary=0;
    if(neighborI!=null && neighborF!=null && boundary!=null)
      for(i=0;i<numberV;i++){
	if(((neighborI[i]) == neighborF[i]) && 
	   (neighborF[i] !=0) && 
	   (neighborI[i] !=0)){
	  boundary[i] = 0;
	}else{
	  boundary[i] = 1;
	  numboundary++;
	}
      }
    //System.out.println("number of boundary points = "+numboundary);
  
  }
  public void SetBoundaryStrips(){
    int i=0;
    IDList now;
     int[] dummyboundary=null;numboundary=0;
    if(neighborI!=null && neighborF!=null && boundary!=null){
      dummyboundary = new int[numberV];
      for(i=0;i<numberV;i++){
	if(((neighborI[i]) == neighborF[i]) && 
	   (neighborF[i] !=0) && 
	   (neighborI[i] !=0)){
	  dummyboundary[i] = 0;
	}else{
	  dummyboundary[i] = 1;
	}
	boundary[i] = 0;
      }
      
      for(i=0;i<numberV;i++){
	if(dummyboundary[i]==1){
	  boundary[i] = 1;
	  //deeplevel[i] = 1;
	  numboundary++;
	  now = VHead[i];
	  while(next(now)!=VTail[i]){
	    now = next(now);
	    if(boundary[now.ID]!=1)
	      boundary[now.ID] = 2;
	    now = next(now);
	  }
	}
      }
    }
  }
  public void MakeArrayObj(int dv){
   int i =0;
   
   myobj = new ViewShape3D(dv);      
   
this.MakeArrayData();
  }
  
  
  public void MakeArrayData(){
    int i=0;
    int j=0;
    updateNormalLine();
    normalarray = new LineArray((numberV*2),GeometryArray.COORDINATES
				| GeometryArray.NORMALS);
    normalarray.setCapability(Geometry.ALLOW_INTERSECT);
    normalarray.setCapability(LineArray.ALLOW_COORDINATE_WRITE);
    normalarray.setCapability(LineArray.ALLOW_NORMAL_WRITE); 
    normalarray.setCoordinates(0,mynormal);
    normalarray.setNormals(0,mynormalnormal);
    myobj.reNew(numberV,numberF,scaler);
    
    int k=0;
    
    /* old shadings */
    for(j=0;j<numberF;j++){
      myobj.MakeFace(j,Face[j][0],Face[j][1],Face[j][2],point);
     
    }
    
    
    // new shading laplace <- normals via updateNormalLine();
    /*
     for(j=0;j<numberF;j++){
	 myobj.MakeFaceN(j,Face[j][0],Face[j][1],Face[j][2],point,laplace);
     
     }
    */
     //end new shading
    
    myobj.MakeArrayData();
    
  }
    public void setParameter(Point3d[] in,int imgS){
	int i=0;
	for(i=0;i<numberF;i++)
	    myobj.setTexCoord(i,Face[i][0],Face[i][1],Face[i][2],in,imgS);
	    
    }
    
  public void  UpdatePolygon(){
    int j=0;
    updateNormalLine();
    normalarray.setCoordinates(0,mynormal);
    normalarray.setNormals(0,mynormalnormal);
    
    /* old shding */
    for(j=0;j<numberF;j++){
      myobj.MakeFace(j,Face[j][0],Face[j][1],Face[j][2],point);
      
    }
    myobj.MakeArrayDataAFTER();
    
  }
    
  public int getNearlestV(Point3d dv){
    int i=0;
    int tar=0;
    double mindist=0.0;
    double dumdist=0.0;
    int firstcheck=0;
    tar = 0;
    for(i=0;i<numberV;i++){
      if(boundary[i]==1){
	if(firstcheck==0){
	  mindist = Distance(dv,point[i]);
	  tar=i;
	  firstcheck=1;
	}else{
	  dumdist = Distance(dv,point[i]);
	  if(dumdist<mindist){
	    mindist = dumdist;
	    tar = i;
	  }
	}
      }
    }
    return tar;
  }
  private IDList getNextCircle(int i,int nowID,int nextID){
    IDList now = VHead[i];
    
    while(next(now)!=VTail[i]){
      now = next(now);
      if((now.ID==nextID)&&(next(now).ID!=nowID))return next(now);
      now = next(now);
    }
    return null;
  }
  



 
  public void setMeanCurvature(){
    int i,j;
    Point3d[] dv = new Point3d[9];
    IDList now;
    boolean secondfirst=true;
    for(i=0;i<9;i++)dv[i] = new Point3d(0.0,0.0,0.0);
    double  tarea = 0.0;
    double area = 0.0;
    aveH=0.0;
    sdviH = 0.0; 
    double angle = 0.0;
    double anglesum=0.0;
    double divisor=0.0;
    double dummytemp=0.0;
    double InnW1=0.0;
    double InnW2=0.0;
    double dl1=0.0;
    double dl2=0.0;
    for(i=0;i<numberV;i++){	divisor += 1.0;
    
      if(boundary[i] !=1){
	
	divisor += 1.0;
	now = VHead[i];
	area = 0.0;area = 0.0; 
	tarea = 0.0;anglesum = 0.0; 
	for(j=0;j<9;j++){
	  dv[j].x = 0.0;dv[j].y = 0.0;dv[j].z = 0.0;
	}
       
	
	
	while(next(now)!=VTail[i]){
	  now = next(now);
	  this.makeVector(dv[0],point[i],point[next(now).ID]);
	  this.makeVector(dv[1],point[next(now).ID],point[now.ID]);
	  this.makeVector(dv[2],point[i],point[now.ID]);
	  this.makeVector(dv[3],point[now.ID],point[next(now).ID]);
	  this.CrossVector(dv[4],dv[2],dv[0]);
	
	  dl1 = Point3dSize(dv[2]);
	  dl2 = Point3dSize(dv[0]);
	  if(dl1==0.0)dl1=1.0;
	  if(dl2==0.0)dl2=1.0;
	  
	  area = ((1.0/2.0)*(Point3dSize(dv[4])));
	  angle = Math.acos((InnerProduct(dv[2],dv[0])/(dl1*dl2)));
	  anglesum+= angle;
	  InnW1 = InnerProduct(dv[0],dv[1]);
	  InnW2 = InnerProduct(dv[2],dv[3]);
	  tarea += area;
	  this.ScalarVector(dv[5],InnW1,dv[2]);
	  this.ScalarVector(dv[6],InnW2,dv[0]);
	  if(area != 0.0){
	    dv[7].x += ((1.0/(4.0*area))*(dv[5].x + dv[6].x));
	    dv[7].y += ((1.0/(4.0*area))*(dv[5].y + dv[6].y));
	    dv[7].z += ((1.0/(4.0*area))*(dv[5].z + dv[6].z));
	    dv[8].x += dv[4].x;
	    dv[8].y += dv[4].y;
	    dv[8].z += dv[4].z;
	    
	  }
	  now = next(now);
	}
		
	dummytemp = Point3dSize(dv[8]);
	if(dummytemp != 0.0){
	  tmppoint3d1.x = ((dv[8].x)/dummytemp);
	  tmppoint3d1.y = ((dv[8].y)/dummytemp);
	  tmppoint3d1.z = ((dv[8].z)/dummytemp);
	}
	
	if(tarea != 0.0){
	  tmppoint3d2.x = -((dv[7].x)/(2.0*tarea));
	  tmppoint3d2.y = -((dv[7].y)/(2.0*tarea));
	  tmppoint3d2.z = -((dv[7].z)/(2.0*tarea));
	}
	//K[i] = 3.0*(2.0*Math.PI - anglesum)/(tarea);
	
	H[i] = 3.0*InnerProduct(tmppoint3d1,tmppoint3d2);
      }else{
	H[i] = 0.0;
      }
      
      
      if(secondfirst){
	secondfirst=false;
	
	aveH = H[i];
	sdviH = (H[i]*H[i]);
      }else{
	
	aveH += H[i];
	sdviH += (H[i]*H[i]);
      }
    }
    
    
    
         
     
    aveH /= divisor;
    sdviH -= (aveH*aveH);
    sdviH /= divisor;
    sdviH = Math.sqrt(sdviH);
    //MeanCurvatureColoring();
  }

public void calMeanCurvature(){
    int i,j;
    Point3d[] dv = new Point3d[9];
    IDList now;
    boolean secondfirst=true;
    for(i=0;i<9;i++)dv[i] = new Point3d(0.0,0.0,0.0);
    double  tarea = 0.0;
    double area = 0.0;
    aveH=0.0;
    sdviH = 0.0; 
    double angle = 0.0;
    double anglesum=0.0;
    double divisor=0.0;
    double dummytemp=0.0;
    double InnW1=0.0;
    double InnW2=0.0;
    double dl1=0.0;
    double dl2=0.0;
    for(i=0;i<numberV;i++){	divisor += 1.0;
    
      if(boundary[i] !=1){
	
	divisor += 1.0;
	now = VHead[i];
	area = 0.0;area = 0.0; 
	tarea = 0.0;anglesum = 0.0; 
	for(j=0;j<9;j++){
	  dv[j].x = 0.0;dv[j].y = 0.0;dv[j].z = 0.0;
	}
       
	
	
	while(next(now)!=VTail[i]){
	  now = next(now);
	  this.makeVector(dv[0],point[i],point[next(now).ID]);
	  this.makeVector(dv[1],point[next(now).ID],point[now.ID]);
	  this.makeVector(dv[2],point[i],point[now.ID]);
	  this.makeVector(dv[3],point[now.ID],point[next(now).ID]);
	  this.CrossVector(dv[4],dv[2],dv[0]);
	
	  dl1 = Point3dSize(dv[2]);
	  dl2 = Point3dSize(dv[0]);
	  if(dl1==0.0)dl1=1.0;
	  if(dl2==0.0)dl2=1.0;
	  
	  area = ((1.0/2.0)*(Point3dSize(dv[4])));
	  angle = Math.acos((InnerProduct(dv[2],dv[0])/(dl1*dl2)));
	  anglesum+= angle;
	  InnW1 = InnerProduct(dv[0],dv[1]);
	  InnW2 = InnerProduct(dv[2],dv[3]);
	  tarea += area;
	  this.ScalarVector(dv[5],InnW1,dv[2]);
	  this.ScalarVector(dv[6],InnW2,dv[0]);
	  if(area != 0.0){
	    dv[7].x += ((1.0/(4.0*area))*(dv[5].x + dv[6].x));
	    dv[7].y += ((1.0/(4.0*area))*(dv[5].y + dv[6].y));
	    dv[7].z += ((1.0/(4.0*area))*(dv[5].z + dv[6].z));
	    dv[8].x += dv[4].x;
	    dv[8].y += dv[4].y;
	    dv[8].z += dv[4].z;
	    
	  }
	  now = next(now);
	}
		
	dummytemp = Point3dSize(dv[8]);
	if(dummytemp != 0.0){
	  tmppoint3d1.x = ((dv[8].x)/dummytemp);
	  tmppoint3d1.y = ((dv[8].y)/dummytemp);
	  tmppoint3d1.z = ((dv[8].z)/dummytemp);
	}
	
	if(tarea != 0.0){
	  tmppoint3d2.x = -((dv[7].x)/(2.0*tarea));
	  tmppoint3d2.y = -((dv[7].y)/(2.0*tarea));
	  tmppoint3d2.z = -((dv[7].z)/(2.0*tarea));
	}
	//K[i] = 3.0*(2.0*Math.PI - anglesum)/(tarea);
	
	H[i] = 3.0*InnerProduct(tmppoint3d1,tmppoint3d2);
      }else{
	H[i] = 0.0;
      }
      
      
      if(secondfirst){
	secondfirst=false;
	
	aveH = H[i];
	sdviH = (H[i]*H[i]);
      }else{
	
	aveH += H[i];
	sdviH += (H[i]*H[i]);
      }
    }
    
    
    
         
     
    aveH /= divisor;
    sdviH -= (aveH*aveH);
    sdviH /= divisor;
    sdviH = Math.sqrt(sdviH);
    
  }


  private void PropertyUpdateB2(Point3d[] out,Point3d[] in){
    int i,j;
    Point3d[] dv = new Point3d[3];
    IDList now;
    for(i=0;i<3;i++)dv[i] = new Point3d(0.0,0.0,0.0);
    double  tarea = 0.0;
    double area = 0.0;
    
    double dl1=0.0;
    double dl2=0.0;
    boolean firstcheck=true;
    for(i=0;i<numberV;i++){
      if(boundary[i] !=1){
	
	now = VHead[i];
	area = 0.0;
	tarea = 0.0;
	for(j=0;j<3;j++){
	  dv[j].x = 0.0;dv[j].y = 0.0;dv[j].z = 0.0;
	}
	
	out[i].x = 0.0;
	out[i].y = 0.0;
	out[i].z = 0.0;
	
	while(next(now)!=VTail[i]){
	  now = next(now);
	  this.makeVector(dv[1],in[i],in[next(now).ID]);
	  
	  this.makeVector(dv[0],in[i],in[now.ID]);
	  
	  this.CrossVector(dv[2],dv[0],dv[1]);
	  
	  dl1 = Point3dSize(dv[0]);
	  dl2 = Point3dSize(dv[1]);
	  if(dl1==0.0)dl1=1.0;
	  if(dl2==0.0)dl2=1.0;
	  
	  area = ((1.0/2.0)*(Point3dSize(dv[2])));
	  //tarea += (area/dl1+area/dl2);
	  tarea += area;
	  out[i].x += area*((in[now.ID].x-in[i].x)/dl1 
			 + (in[next(now).ID].x-in[i].x)/dl2);
	  out[i].y += area*((in[now.ID].y-in[i].y)/dl1 
			 + (in[next(now).ID].y-in[i].y)/dl2);
	  out[i].z += area*((in[now.ID].z-in[i].z)/dl1 
			 + (in[next(now).ID].z-in[i].z)/dl2);
	  
	  
	  now = next(now);
	}
	if(tarea!=0.0){
	  
	  out[i].x /= (2.0*tarea*((double)(neighborI[i])));
	  out[i].y /= (2.0*tarea*((double)(neighborI[i])));
	  out[i].z /= (2.0*tarea*((double)(neighborI[i])));
	  /*
	  out[i].x /= (tarea);
	  out[i].y /= (tarea);
	  out[i].z /= (tarea);*/
	  if(firstcheck){
	    firstcheck=false;
	    minarea = tarea;
	  }else{
	    if(minarea>tarea)minarea = tarea;
	  }
	
	}
	
      }else{
	out[i].x = 0.0;
	out[i].y = 0.0;
	out[i].z = 0.0;
	
	
      }
    }
  }
  private void MakeTangentsBAfterL(Point3d[] out,Point3d[] in){
    int i,j;
    double divisorDNVec1,divisorDNVec2,dummytemp;
    IDList now;
    RefleshBE();

    for(i=0;i<numberV;i++){
      if(boundary[i]==1){
	divisorDNVec1 = 0.0;divisorDNVec2=0.0;dummytemp=0.0;
	 now = VHead[i];
	 while(next(now)!=VTail[i]){
	   now = next(now);
	   AppendBE(now.ID);
	   now = next(now);
	   AppendBE(now.ID);
	 
	 }
	 	   
	   
	  (bilaplace[i]).x = laplace[i].x/((double)(neighborI[i]));
	  (bilaplace[i]).y = laplace[i].y/((double)(neighborI[i]));
	  (bilaplace[i]).z = laplace[i].z/((double)(neighborI[i]));
	 divisorDNVec1 = Distance(in[i],in[next(BEHead).ID]);
	 if(divisorDNVec1==0.0)divisorDNVec1=1.0;
	 divisorDNVec2 = Distance(in[i],in[back(BETail).ID]);
	 if(divisorDNVec2==0.0)divisorDNVec2=1.0;
	 
	 out[i].x = ((in[next(BEHead).ID].x - in[i].x)/divisorDNVec1
		     + (in[i].x - in[back(BETail).ID].x)/divisorDNVec2
		     - ((in[next(BEHead).ID].x - in[back(BETail).ID].x)/
			(divisorDNVec1 + divisorDNVec2)));
	  out[i].y = ((in[next(BEHead).ID].y - in[i].y)/divisorDNVec1
		     + (in[i].y - in[back(BETail).ID].y)/divisorDNVec2
		     - ((in[next(BEHead).ID].y - in[back(BETail).ID].y)/
			(divisorDNVec1 + divisorDNVec2)));
	  out[i].z = ((in[next(BEHead).ID].z - in[i].z)/divisorDNVec1
		     + (in[i].z - in[back(BETail).ID].z)/divisorDNVec2
		     - ((in[next(BEHead).ID].z - in[back(BETail).ID].z)/
			(divisorDNVec1 + divisorDNVec2)));
	  
	  dummytemp = Point3dSize(out[i]);
	  if(dummytemp != 0.0){
	    out[i].x /= dummytemp;
	    out[i].y /= dummytemp;
	    out[i].z /= dummytemp;
	  }
	  RefleshBE();	  	
      }
    
    }
  
  }
  private void PropertyWL(Point3d[] out,Point3d[] in,double[] weight){
    int i=0;
    double lapdivisor=0.0;
    IDList now;
    for(i=0;i<numberV;i++){
      if(neighborI[i]!=0){
	now = IHead[i];
	lapdivisor=0.0;
	out[i].x = 0.0;
	out[i].y = 0.0;
	out[i].z = 0.0;
	while(next(now)!=ITail[i]){
	  now = next(now);
	  lapdivisor += 1.0/(1.0+weight[now.ID]);
	  out[i].x += (1.0/(1.0+weight[now.ID]))*(in[now.ID].x - in[i].x);
	  out[i].y += (1.0/(1.0+weight[now.ID]))*(in[now.ID].y - in[i].y);
	  out[i].z += (1.0/(1.0+weight[now.ID]))*(in[now.ID].z - in[i].z);
	}
	
	if(lapdivisor!=0.0){
	  out[i].x /= lapdivisor;
	  out[i].y /= lapdivisor;
	  out[i].z /= lapdivisor;
	}
      }
    }
	
  
  }
    
  private void PropertyL(Point3d[] out,Point3d[] in){
    int i=0;
    double lapdivisor=0.0;
    IDList now;
    for(i=0;i<numberV;i++){
      if(neighborI[i]!=0){
	now = IHead[i];
	lapdivisor=0.0;
	out[i].x = 0.0;
	out[i].y = 0.0;
	out[i].z = 0.0;
	while(next(now)!=ITail[i]){
	  now = next(now);
	  lapdivisor += 1.0;
	  out[i].x += (in[now.ID].x - in[i].x);
	  out[i].y += (in[now.ID].y - in[i].y);
	  out[i].z += (in[now.ID].z - in[i].z);
	}
	
	if(lapdivisor!=0.0){
	  out[i].x /= lapdivisor;
	  out[i].y /= lapdivisor;
	  out[i].z /= lapdivisor;
	}
      }
    }
	
  
  }

   private void PropertyLB(Point3d[] out,Point3d[] in){
    
    int i,j;
    Point3d[] dv = new Point3d[10];
    IDList now;
    
    for(i=0;i<10;i++)dv[i] = new Point3d(0.0,0.0,0.0);
    double  tarea = 0.0;
    double area = 0.0;
    
    double InnW1=0.0;
    double InnW2=0.0;
    
    for(i=0;i<numberV;i++){
      if(boundary[i] !=1){
	
	now = VHead[i];
	area = 0.0;
	tarea = 0.0;
	for(j=0;j<10;j++){
	  dv[j].x = 0.0;dv[j].y = 0.0;dv[j].z = 0.0;
	}
	 
	in[i].x = 0.0;
	in[i].y = 0.0;
	in[i].z = 0.0;
	
	while(next(now)!=VTail[i]){
	  now = next(now);
	  this.makeVector(dv[0],point[i],point[next(now).ID]);
	  this.makeVector(dv[1],point[next(now).ID],point[now.ID]);
	  this.makeVector(dv[2],point[i],point[now.ID]);
	  this.makeVector(dv[3],point[now.ID],point[next(now).ID]);
	  this.CrossVector(dv[4],dv[2],dv[0]);
	  this.makeVector(dv[8],in[i],in[next(now).ID]);
	  this.makeVector(dv[9],in[i],in[now.ID]);
	  
	  
	  area = ((1.0/2.0)*(Point3dSize(dv[4])));
	  
	  InnW1 = InnerProduct(dv[0],dv[1]);
	  InnW2 = InnerProduct(dv[2],dv[3]);
	  tarea += area;
	  this.ScalarVector(dv[5],InnW1,dv[9]);
	  this.ScalarVector(dv[6],InnW2,dv[8]);
	  if(area != 0.0){
	    dv[7].x += ((1.0/(4.0*area))*(dv[5].x + dv[6].x));
	    dv[7].y += ((1.0/(4.0*area))*(dv[5].y + dv[6].y));
	    dv[7].z += ((1.0/(4.0*area))*(dv[5].z + dv[6].z));
	  }
	  now = next(now);
	}
	
	
	if(tarea != 0.0){
	  out[i].x = -((dv[7].x)/(2.0*tarea));
	  out[i].y = -((dv[7].y)/(2.0*tarea));
	  out[i].z = -((dv[7].z)/(2.0*tarea));
	}
	
	
      }else{
      }
    }
  } 


    public void resetHinfo(double [] val,double [] avesdiv){
	int i;
	avesdiv[0] = 0.0;
	avesdiv[1] = 0.0;
	
	for(i=0;i<numberV;i++){
	    avesdiv[0] += val[i];
	    avesdiv[1] += (val[i]*val[i]); 
	}
	avesdiv[0] /= ((double)(numberV));
	avesdiv[1] -= (avesdiv[0]*avesdiv[0]);
	avesdiv[1] /= ((double)(numberV));
	avesdiv[1] = Math.sqrt(avesdiv[1]);
    } 
    
    
 
 public void ZscoreNormalization(double [] in,double [] k,double [] avesdiv){
    
    int i;
    double dumMax = 0.0;
    double dumMin=0.0;
    
    double thr = threshold*avesdiv[1];
    for(i=0;i<numberV;i++){
      if(boundary[i] != 1){
	if(Math.abs((in[i] - avesdiv[0])) >= thr){
	  if((in[i] - avesdiv[0])<0.0){
	    k[i] = avesdiv[0] - thr;
	  }else{
	    k[i] = avesdiv[0] + thr;
	  }
	}else{
	  k[i] = in[i];
	}
      }
    }
    boolean first=true;
    for(i=0;i<numberV;i++){
      if(boundary[i] != 1){
	if(first){
	  first=false;
	  dumMax = k[i];
	  dumMin = dumMax;
	}else{
	  if(k[i]>dumMax)dumMax = k[i];
	  if(k[i]<dumMin)dumMin = k[i];
	}
      }
    }
    
    for(i=0;i<numberV;i++)
      if(boundary[i] != 1){
	k[i] -= dumMin;
	k[i] /= (dumMax-dumMin);
	if(k[i]<0)k[i] = 0.0;
	if(k[i]>1.0)k[i] = 1.0;
      }
 } 
    
 
  public void MeanCurvatureColoring(){
    
    
    double [] avesdiv = new double[3];
    avesdiv[0] = aveH;
    avesdiv[1] = sdviH;
    
    double[] k = new double[numberV];
    ZscoreNormalization(H,k,avesdiv);
    myobj.setPastelColor(k,Face);
    myobj.setColor(false);
  } 
  public void DistanceColoring(double [] dist){
      double [] avesdiv = new double[3];
      
      resetHinfo(dist,avesdiv);
      double[] k = new double[numberV];
      ZscoreNormalization(dist,k,avesdiv);
      
      myobj.setPastelColorBi(k,Face);myobj.setColor(false);
  } 
  public void SimilarityColoring(double [] sim){
      double [] avesdiv = new double[3];
      
      resetHinfo(sim,avesdiv);
      double[] k = new double[numberV];
      ZscoreNormalization(sim,k,avesdiv);
     
      myobj.setbipolarColor(k,Face);myobj.setColor(false);
  } 
  







 private boolean SearchBE(int dID){
    
    IDList now = BEHead;
    IDList dummynext;
    IDList dummyback;
    
    while(next(now)!=BETail){
      now = next(now);
      if((now.ID==dID)){
	dummyback = now.back;
	dummynext = now.next;
	dummyback.next = dummynext;
	dummynext.back = dummyback;
	return true;
      }
    }
    return false;
  }
 
   private void AppendBE(int dID)
    {
      
	if(!SearchBE(dID)){
	  IDList now = new IDList(dID);
	  IDList dummy = BETail.back;
	  now.next = BETail;
	  BETail.back = now;
	  now.back = dummy;
	  dummy.next =now;
	}else{
	  
	}
    }
  private void RefleshBE(){
    
      BEHead = new IDList();
      BETail = new IDList();
      BEHead.next = BETail;
      BETail.back = BEHead;
    } 
    
  private void setMBEE1(Point3d out,int v1,int v2){
    
    setExtraordinaryInterior(tmppoint3d1,v1,v2);
    setExtraordinaryInterior(tmppoint3d2,v2,v1);
    out.x = 0.5*(tmppoint3d1.x + tmppoint3d2.x);
    out.y = 0.5*(tmppoint3d1.y + tmppoint3d2.y);
    out.z = 0.5*(tmppoint3d1.z + tmppoint3d2.z);
  }
  private void setMBEE2(Point3d out,int v1,int v2){
    if(boundary[v1]==1){
     setExtraordinaryInterior(tmppoint3d2,v2,v1);
     setExtraordinaryBoundary(tmppoint3d1,v1,v2);
    }else if(boundary[v2]==1){
      setExtraordinaryBoundary(tmppoint3d2,v2,v1);
      setExtraordinaryInterior(tmppoint3d1,v1,v2);
    }   
    out.x = 0.5*(tmppoint3d1.x + tmppoint3d2.x);
    out.y = 0.5*(tmppoint3d1.y + tmppoint3d2.y);
    out.z = 0.5*(tmppoint3d1.z + tmppoint3d2.z);
  }
  private void setMBEE3(Point3d out,int v1,int v2){
    
    setExtraordinaryBoundary(tmppoint3d1,v1,v2);
    setExtraordinaryBoundary(tmppoint3d2,v2,v1);
    out.x = 0.5*(tmppoint3d1.x + tmppoint3d2.x);
    out.y = 0.5*(tmppoint3d1.y + tmppoint3d2.y);
    out.z = 0.5*(tmppoint3d1.z + tmppoint3d2.z);
  }
  
  
  private void setExtraordinaryInterior(Point3d out,int dv,int another){
    double dx=0.0;
    double dy=0.0;
    double dz=0.0;
    if(neighborI[dv]==3){
      int id1=0;
      int id2=0;
      if(next(IHead[dv]).ID==another){
	id1 = next(next(IHead[dv])).ID;
	id2 = back(ITail[dv]).ID;
      }else if(next(next(IHead[dv])).ID==another){
	id1 = next(IHead[dv]).ID;
	id2 = back(ITail[dv]).ID;
      }else if(back(ITail[dv]).ID==another){
	id1 = next(IHead[dv]).ID;
	id2 = next(next(IHead[dv])).ID;
      }
      out.x = ((5.0/12.0)*point[another].x - (1.0/12.0)*(point[id1].x + point[id2].x)+0.75*point[dv].x);
      out.y = ((5.0/12.0)*point[another].y - (1.0/12.0)*(point[id1].y + point[id2].y)+0.75*point[dv].y);
      out.z = ((5.0/12.0)*point[another].z - (1.0/12.0)*(point[id1].z + point[id2].z)+0.75*point[dv].z);
      

    }else if(neighborI[dv]==4){
      int id1=0;
      int did1=0;
      int did2=0;
      int tmp111=0;
      boolean bcheck=true;
      IDList now = FHead[dv];
      while(next(now)!=FTail[dv]){
	now = next(now);
	tmp111 = checktopbottomLR(now.ID,dv,another);
	if(tmp111!=-1){
	  if(bcheck){
	    did1 = tmp111;
	    bcheck=false;
	  }else{
	    if(tmp111!=did1){
	      did2 = tmp111;
	      break;
	    }
	  }
	}
      }
       now = IHead[dv];
      while(next(now)!=ITail[dv]){
	now = next(now);
	if((now.ID!=another)&&(now.ID!=did1)&&(now.ID!=did2)){
	  id1 = now.ID;
	  break;
	}
      }
      //System.out.println("another = "+another+" id1 = "+id1);
      out.x = (0.125*(3.0*point[another].x - point[id1].x)+0.75*point[dv].x);
      out.y = (0.125*(3.0*point[another].y - point[id1].y)+0.75*point[dv].y);
      out.z = (0.125*(3.0*point[another].z - point[id1].z)+0.75*point[dv].z);
      
    }else if(neighborI[dv]>=5){
      dx=0.0;
      dy=0.0;
      dz=0.0;
      double di=0.0;
      double dvalance = ((double)(neighborI[dv]));
      double weight=0.0;
      int nextid=another;
      IDList now;
      double tweight = 0.0;
      for(int j=0;j<neighborI[dv];j++){
	now = VHead[dv];
	while(next(now)!=VTail[dv]){
	  now = next(now);
	  if(now.ID==nextid){
	    weight = (0.25+Math.cos(((2.0*Math.PI*di)/dvalance))
		      +0.5*Math.cos(((4.0*Math.PI*di)/dvalance)))/dvalance;
	    tweight += weight;
	    dx += weight*point[now.ID].x;
	    dy += weight*point[now.ID].y;
	    dz += weight*point[now.ID].z;
	    di+=1.0;
	    nextid = next(now).ID;
	    break;
	  }
	  now = next(now);
	}
      }
      
      dx += (1.0 - tweight)*point[dv].x;
      dy += (1.0 - tweight)*point[dv].y;
      dz += (1.0 - tweight)*point[dv].z;
      out.x = dx;
      out.y = dy;
      out.z = dz;
    }
  }
  
  private void setExtraordinaryBoundary(Point3d out,int dv,int another){
    double dx=0.0;
    double dy=0.0;
    double dz=0.0;
    int i=0;
    int top=0;
    boolean bbcheck=true;
    IDList nowv1 = FHead[dv];
    int numtb=0;
    while(next(nowv1)!=FTail[dv]){
      nowv1 = next(nowv1);
      i = checktopbottomLR(nowv1.ID,dv,another);
      if(i!=-1){
	numtb++;
      }
    }
   
    int did1=0;
    int did2=0;
    nowv1 = IHead[dv];
    while(next(nowv1)!=ITail[dv]){
      nowv1 = next(nowv1);
      if((boundary[nowv1.ID]==1)&&(nowv1.ID!=another)){
	did1 = nowv1.ID;
	  break;
      }
    }
    nowv1 = IHead[another];
    while(next(nowv1)!=ITail[another]){
      nowv1 = next(nowv1);
      if((boundary[nowv1.ID]==1)&&(nowv1.ID!=dv)){
	  did2 = nowv1.ID;
	  break;
      }
      }
    
    dx = ((9.0/16.0)*(point[dv].x + point[another].x) 
	  - (1.0/16.0)*(point[did1].x + point[did2].x));
    dy = ((9.0/16.0)*(point[dv].y + point[another].y) 
	  - (1.0/16.0)*(point[did1].y + point[did2].y));
    dz = ((9.0/16.0)*(point[dv].z + point[another].z) 
	  - (1.0/16.0)*(point[did1].z + point[did2].z));
    out.x = dx;
    out.y = dy;
    out.z = dz;
  }
  private void setMBRBB(Point3d out,int v1,int v2){
    double dx=0.0;
    double dy=0.0;
    double dz=0.0;
    int i=0;

    int j=0;
    int top=0;
    int bottom=0;
    boolean bbcheck=true;
    IDList nowv1 = FHead[v1];
    int tmp1=0;
    int numtb=0;
    while(next(nowv1)!=FTail[v1]){
      nowv1 = next(nowv1);
      i = checktopbottomLR(nowv1.ID,v1,v2);
      if(i!=-1){
	if(bbcheck){
	  top = i;
	  numtb++;
	  bbcheck=false;
	}else{
	  if(i!=top){
	    bottom=i;
	    numtb++;
	    break;
	  }
	}
      }
    }
    
    if(numtb<=1){
      /* regular */
      int did1=0;
      int did2=0;
      nowv1 = IHead[v1];
      while(next(nowv1)!=ITail[v1]){
	nowv1 = next(nowv1);
	if((boundary[nowv1.ID]==1)&&(nowv1.ID!=v2)){
	  did1 = nowv1.ID;
	  break;
	}
      }
      nowv1 = IHead[v2];
      while(next(nowv1)!=ITail[v2]){
	nowv1 = next(nowv1);
	if((boundary[nowv1.ID]==1)&&(nowv1.ID!=v1)){
	  did2 = nowv1.ID;
	  break;
	}
      }
      
      dx = ((9.0/16.0)*(point[v1].x + point[v2].x) 
	    - (1.0/16.0)*(point[did1].x + point[did2].x));
      dy = ((9.0/16.0)*(point[v1].y + point[v2].y) 
	    - (1.0/16.0)*(point[did1].y + point[did2].y));
      dz = ((9.0/16.0)*(point[v1].z + point[v2].z) 
	    - (1.0/16.0)*(point[did1].z + point[did2].z));
      

      out.x = dx;
      out.y = dy;
      out.z = dz;
      //System.out.println("dv1 = "+boundary[did1]+" dv2 = "+boundary[did2]);
      
      /*
      out.x = 0.5*(point[v1].x + point[v2].x);
      out.y = 0.5*(point[v1].y + point[v2].y);
      out.z = 0.5*(point[v1].z + point[v2].z);
      */
    }else{
      if((boundary[top]==1) && (boundary[bottom]==1)){
	/* case 2 */
	out.x = 0.5*(point[v1].x + point[v2].x);
	out.y = 0.5*(point[v1].y + point[v2].y);
	out.z = 0.5*(point[v1].z + point[v2].z);
      }else{
	/* case 1 */
	int tmp=0;
	if(boundary[bottom]==1){
	  tmp = top;
	  top = bottom;
	  bottom = tmp;
	}
	int bottomRL1=0;
	int bottomRL2=0;
	
	IDList nowt = FHead[v1];
	while(next(nowt)!=FTail[v1]){
	  nowt = next(nowt);
	  tmp1 = checktopbottomLR(nowt.ID,v1,bottom);
	  if((tmp1!=-1)&&(tmp1!=v2)){
	    bottomRL1 = tmp1;
	    break;
	  }
	}
	nowt = FHead[v2];
	while(next(nowt)!=FTail[v2]){
	  nowt = next(nowt);
	  tmp1 = checktopbottomLR(nowt.ID,v2,bottom);
	  if((tmp1!=-1)&&(tmp1!=v1)){
	    bottomRL2 = tmp1;
	    break;
	  }
	}
	
	
	out.x = 0.5*(point[v1].x + point[v2].x) + 0.25*point[bottom].x 
	  - 0.125*(point[bottomRL1].x + point[bottomRL2].x);
	out.y = 0.5*(point[v1].y + point[v2].y)+ 0.25*point[bottom].y 
	  - 0.125*(point[bottomRL1].y + point[bottomRL2].y);
	out.z = 0.5*(point[v1].z + point[v2].z)+ 0.25*point[bottom].z 
	  - 0.125*(point[bottomRL1].z + point[bottomRL2].z);
	out.x = dx;
	out.y = dy;
	out.z = dz;
	
      }
    }
    
  }
private void setMBRIB(Point3d out,int dv1,int dv2){
    int v1,v2;
    if(boundary[dv1]==1){
      v1=dv1;
      v2=dv2;
    }else{
      v1=dv2;
      v2=dv1;
    }
    double dx=0.0;
    double dy=0.0;
    double dz=0.0;
    IDList nowv1 = FHead[v1];
    int top=0;
    int bottom=0;
    int i=0;
    boolean bbcheck=true;
    int tmp1=0;
    while(next(nowv1)!=FTail[v1]){
      nowv1 = next(nowv1);
      i = checktopbottomLR(nowv1.ID,v1,v2);
      if(i!=-1){
	if(bbcheck){
	  top = i;
	  bbcheck=false;
	}else{
	  if(i!=top){
	    bottom=i;
	    break;
	  }
	}
      }
    }
    if(boundary[top]==1){
    }else{
      int tmp = top;
      top = bottom;
      bottom = tmp;
    }
    int topright=0;
    int bottomright=0;
    IDList nowt = FHead[v2];
    while(next(nowt)!=FTail[v2]){
      nowt = next(nowt);
      tmp1 = checktopbottomLR(nowt.ID,v2,top);
      if((tmp1!=-1)&&(tmp1!=v1)){
	topright = tmp1;
	break;
      }
    }
    nowt = FHead[v2];
    while(next(nowt)!=FTail[v2]){
      nowt = next(nowt);
      tmp1 = checktopbottomLR(nowt.ID,v2,bottom);
      if((tmp1!=-1)&&(tmp1!=v1)){
	bottomright = tmp1;
	break;
      }
    }
    

    int bottomleft=0;


     nowt = FHead[v1];
    while(next(nowt)!=FTail[v1]){
      nowt = next(nowt);
      tmp1 = checktopbottomLR(nowt.ID,v1,bottom);
      if((tmp1!=-1)&&(tmp1!=v2)){
	bottomleft = tmp1;
	break;
      }
    }
    dx = 0.125*(5.0*point[v2].x + 3.0*point[v1].x - point[bottomright].x)
      +0.0625*(point[top].x + 3.0*point[bottom].x -point[topright].x - point[bottomleft].x);
    dy = 0.125*(5.0*point[v2].y + 3.0*point[v1].y - point[bottomright].y)
      +0.0625*(point[top].y + 3.0*point[bottom].y -point[topright].y - point[bottomleft].y);
    dz = 0.125*(5.0*point[v2].z + 3.0*point[v1].z - point[bottomright].z)
      +0.0625*(point[top].z + 3.0*point[bottom].z -point[topright].z - point[bottomleft].z);
    out.x = dx;
    out.y = dy;
    out.z = dz;
  }
  private void setMBStandardRule(Point3d out,int v1,int v2){
    double dx=0.0;
    double dy=0.0;
    double dz=0.0;
    int i=0;
    int top=0;
    int bottom=0;
    boolean bbcheck=true;
    IDList nowv1 = FHead[v1];
    int numc=0;
    while(next(nowv1)!=FTail[v1]){
      nowv1 = next(nowv1);
      i = checktopbottomLR(nowv1.ID,v1,v2);
      if(i!=-1){
	if(bbcheck){
	  top = i;numc++;
	  bbcheck=false;
	}else{
	  if(i!=top){
	    bottom=i;numc++;
	    break;
	  }
	}
      }
    }
    if(numc!=2){
      System.out.println("Error !!!"+numc);

    }
    
    

    int topright=0;
    int bottomright=0;
    int tmp1=0;
    
    IDList nowt = FHead[v1];
    while(next(nowt)!=FTail[v1]){
      nowt = next(nowt);
      tmp1 = checktopbottomLR(nowt.ID,v1,top);
      if((tmp1!=-1)&&(tmp1!=v2)){
	topright = tmp1;
	break;
      }
    }
    nowt = FHead[v1];
    while(next(nowt)!=FTail[v1]){
      nowt = next(nowt);
      tmp1 = checktopbottomLR(nowt.ID,v1,bottom);
      if((tmp1!=-1)&&(tmp1!=v2)){
	bottomright = tmp1;
	break;
      }
    }
    
    int topleft=0;
    int bottomleft=0;
    
    nowt = FHead[v2];
    while(next(nowt)!=FTail[v2]){
      nowt = next(nowt);
      tmp1 = checktopbottomLR(nowt.ID,v2,top);
	if((tmp1!=-1)&&(tmp1!=v1)){
	  topleft = tmp1;
	break;
	}
    }
    nowt = FHead[v2];
    while(next(nowt)!=FTail[v2]){
      nowt = next(nowt);
      tmp1 = checktopbottomLR(nowt.ID,v2,bottom);
      if((tmp1!=-1)&&(tmp1!=v1)){
	bottomleft = tmp1;
	break;
      }
    }
    /*
    System.out.println("v1 = "+v1);
    System.out.println("v2 = "+v2);
    System.out.println("top = "+top);
    System.out.println("bottom = "+bottom);
    System.out.println("topright = "+topright);
    System.out.println("bottomright = "+bottomright);
    System.out.println("topleft = "+topleft);
    System.out.println("bottomleft = "+bottomleft);
    */

    dx = 0.5*(point[v1].x + point[v2].x) 
      + 0.125*(point[top].x + point[bottom].x) 
      - 0.0625*(point[topright].x + point[topleft].x
		+ point[bottomright].x+ point[bottomleft].x);
    dy = 0.5*(point[v1].y + point[v2].y) 
      + 0.125*(point[top].y + point[bottom].y) 
      - 0.0625*(point[topright].y + point[topleft].y
		+ point[bottomright].y+ point[bottomleft].y);
    dz = 0.5*(point[v1].z + point[v2].z) 
      + 0.125*(point[top].z + point[bottom].z) 
      - 0.0625*(point[topright].z + point[topleft].z
		+ point[bottomright].z+ point[bottomleft].z);
    out.x = dx;
    out.y = dy;
    out.z = dz;    
  }
  private int checktopbottomLR(int fid,int dv,int topbottom){
    if(((Face[fid][0]==dv)&&(Face[fid][1]==topbottom))||
       ((Face[fid][1]==dv)&&(Face[fid][0]==topbottom))
       ){
      return Face[fid][2];
    }else if(((Face[fid][0]==dv)&&(Face[fid][2]==topbottom))||
	     ((Face[fid][2]==dv)&&(Face[fid][0]==topbottom))
	     ){
      return Face[fid][1];
    }else if(((Face[fid][1]==dv)&&(Face[fid][2]==topbottom))||
	     ((Face[fid][2]==dv)&&(Face[fid][1]==topbottom))
	     ){
      return Face[fid][0];

    }else{
      return -1;
    }

  }
  private void setModButterfly(Point3d out,int v1,int v2){
    if(((boundary[v1]==0)&&(neighborI[v1]==6))&&
       ((boundary[v2]==0)&&(neighborI[v2]==6))){
      /* regular interior-regular interior */
      /* standard rule */
        setMBStandardRule(out,v1,v2);
    }else if((((boundary[v1]==0)&&(neighborI[v1]==6))&&
	      ((boundary[v2]==1)&&(neighborI[v2]==4)))||
	     (((boundary[v1]==1)&&(neighborI[v1]==4))&&
	      ((boundary[v2]==0)&&(neighborI[v2]==6)))
	     ){
      /* regular interior-regular boundary */
      /* regular interior-boundary  rule */
      
      setMBRIB(out,v1,v2);
      
    }else if(((boundary[v1]==1)&&(neighborI[v1]==4))&&
	     ((boundary[v2]==1)&&(neighborI[v2]==4))){
      /* regular boundary-regular boundary */
      /* regular boundary-boundary rule 1 or 2 */
      setMBRBB(out,v2,v1);
    }else if(((boundary[v1]==0)&&(neighborI[v1]!=6))&&
	      ((boundary[v2]==0)&&(neighborI[v2]!=6))){
      /* extraordinary interior-extraordinary interior */
      setMBEE1(out,v2,v1);
    }else if((((boundary[v1]==1)&&(neighborI[v1]!=4))&&
	      ((boundary[v2]==0)&&(neighborI[v2]!=6)))||
	     (((boundary[v1]==0)&&(neighborI[v1]!=6))&&
	      ((boundary[v2]==1)&&(neighborI[v2]!=4)))){
      /* extraordinary interior-extraordinary boundary */
      //setMBEE2(out,v2,v1);
      out.x  = 0.5*(point[v1].x + point[v2].x);
      out.y = 0.5*(point[v1].y + point[v2].y);
      out.z = 0.5*(point[v1].z + point[v2].z);
    }else if(((boundary[v1]==1)&&(neighborI[v1]!=4))&&
	      ((boundary[v2]==1)&&(neighborI[v2]!=4))){
      /* extraordinary boundary-extraordinary boundary */
      setMBEE3(out,v2,v1);
    }else if((((boundary[v1]==0)&&(neighborI[v1]==6))&&
	      ((boundary[v2]==0)&&(neighborI[v2]!=6)))||
	     (((boundary[v1]==0)&&(neighborI[v1]!=6))&&
	      ((boundary[v2]==0)&&(neighborI[v2]==6)))){
      if(neighborI[v1]!=6){
	setExtraordinaryInterior(out,v1,v2);
      }else if(neighborI[v2]!=6){
	setExtraordinaryInterior(out,v2,v1);
      }
    }else if((((boundary[v1]==1)&&(neighborI[v1]==4))&&
	       ((boundary[v2]==0)&&(neighborI[v2]!=6)))||
	      (((boundary[v1]==0)&&(neighborI[v1]!=6))&&
	       ((boundary[v2]==1)&&(neighborI[v2]==4)))){
      if(neighborI[v1]!=6){
	setExtraordinaryInterior(out,v1,v2);
      }else if(neighborI[v2]!=6){
	setExtraordinaryInterior(out,v2,v1);
      }
      
    }else if(((((boundary[v1]==0)&&(neighborI[v1]==6))&&
	       ((boundary[v2]==1)&&(neighborI[v2]!=4)))||
	      (((boundary[v1]==1)&&(neighborI[v1]!=4))&&
	       ((boundary[v2]==0)&&(neighborI[v2]==6))))
	     ){
      /*
      if(neighborI[v1]!=4){
	setExtraordinaryBoundary(out,v1,v2);
      }else if(neighborI[v2]!=4){
	setExtraordinaryBoundary(out,v2,v1);
      }
      */
      
      out.x  = 0.5*(point[v1].x + point[v2].x);
      out.y = 0.5*(point[v1].y + point[v2].y);
      out.z = 0.5*(point[v1].z + point[v2].z);
      
      
    }else if(((((boundary[v1]==1)&&(neighborI[v1]==4))&&
	       ((boundary[v2]==1)&&(neighborI[v2]!=4)))||
	      (((boundary[v1]==1)&&(neighborI[v1]!=4))&&
	       ((boundary[v2]==1)&&(neighborI[v2]==4))))
	     ){
      if(neighborI[v1]!=4){
	setExtraordinaryBoundary(out,v1,v2);
      }else if(neighborI[v2]!=4){
	setExtraordinaryBoundary(out,v2,v1);
      }
      
      
    }else{
      System.out.println("Error setModButterfly!!");
      System.exit(0);
    }
  }

       
  public void SubDivideModButterfly(){
    int i,j;
    
    Point3d tmpposition = new Point3d(0.0,0.0,0.0);
    int numberVnew = numberV + numberE;
    int numberFnew = 4*numberF;
    System.out.println("new numberV = "+numberVnew);
    System.out.println("new numberF = "+numberFnew);
    
    subpoint = new Point3d[numberVnew];
    subFace = new int[numberFnew][3];
   
    
    int Dface[][] = new int[numberV][numberV];
   
    System.out.println("Start subdivision ");
    for(i=0;i<numberV;i++){
      subpoint[i] = new Point3d(point[i].x,point[i].y,point[i].z);
    }
    int vpointer=numberV;
    for(i=0;i<numberF;i++){
      
     if(Dface[Face[i][0]][Face[i][1]]==0){
       
       setModButterfly(tmpposition,Face[i][0],Face[i][1]);
       subpoint[vpointer] = new Point3d(tmpposition.x,tmpposition.y,tmpposition.z);
       Dface[Face[i][0]][Face[i][1]] = vpointer;
	Dface[Face[i][1]][Face[i][0]] = vpointer;
	vpointer++;
     }
     if(Dface[Face[i][1]][Face[i][2]]==0){
       setModButterfly(tmpposition,Face[i][1],Face[i][2]);
       subpoint[vpointer] = new Point3d(tmpposition.x,tmpposition.y,tmpposition.z);
       Dface[Face[i][1]][Face[i][2]] = vpointer;
       Dface[Face[i][2]][Face[i][1]] = vpointer;
       vpointer++;
     }
     if(Dface[Face[i][2]][Face[i][0]]==0){ 
       setModButterfly(tmpposition,Face[i][2],Face[i][0]);
       
       subpoint[vpointer] = new Point3d(tmpposition.x,tmpposition.y,tmpposition.z);
       Dface[Face[i][2]][Face[i][0]] = vpointer;
       Dface[Face[i][0]][Face[i][2]] = vpointer;
       vpointer++;
     } 
     
    }
    //System.out.println("vpointer = "+vpointer);
    for(i=0;i<numberF;i++){
      subFace[4*i][0] = Face[i][0];
      subFace[4*i][1] = Dface[Face[i][0]][Face[i][1]];
      subFace[4*i][2] = Dface[Face[i][2]][Face[i][0]];
      
      subFace[4*i+1][0] = Dface[Face[i][0]][Face[i][1]];
      subFace[4*i+1][1] = Face[i][1];
      subFace[4*i+1][2] = Dface[Face[i][1]][Face[i][2]];
      
      subFace[4*i+2][0] = Dface[Face[i][2]][Face[i][0]];
      subFace[4*i+2][1] = Dface[Face[i][1]][Face[i][2]];
      subFace[4*i+2][2] = Face[i][2];
      
      subFace[4*i+3][0] = Dface[Face[i][0]][Face[i][1]];
      subFace[4*i+3][1] = Dface[Face[i][1]][Face[i][2]];
      subFace[4*i+3][2] = Dface[Face[i][2]][Face[i][0]];
            
    }
    
    numberV = numberVnew;
    numberF = numberFnew;
    numberE = numberVnew + numberFnew - EulerC;
    UpdatePolyStructure();
  }


    
  private void setModLoop(Point3d out,int v1,int v2){
    
    if((boundary[v1]==1)&&(boundary[v2]==1)){
      out.x = 0.5*(point[v1].x + point[v2].x);
      out.y = 0.5*(point[v1].y + point[v2].y);
      out.z = 0.5*(point[v1].z + point[v2].z);
    }else if(((boundary[v1]==1)&&(boundary[v2]==0))||
	     ((boundary[v1]==0)&&(boundary[v2]==1))){
      IDList nowv1 = FHead[v1];
      int top=0;
      int bottom=0;
      int i=0;
      boolean bbcheck=true;
      while(next(nowv1)!=FTail[v1]){
	nowv1 = next(nowv1);
	i = checktopbottomLR(nowv1.ID,v1,v2);
	if(i!=-1){
	  if(bbcheck){
	    top = i;
	    bbcheck=false;
	  }else{
	    if(i!=top){
	      bottom=i;
	    break;
	    }
	  }
	}
      }
      int tmp=0;
      if(boundary[v1]==1){
	out.x = (0.5*point[v1].x + 0.25*point[v2].x)
	  +0.125*(point[top].x + point[bottom].x);
	out.y = (0.5*point[v1].y + 0.25*point[v2].y)
	  +0.125*(point[top].y + point[bottom].y);
	out.z = (0.5*point[v1].z + 0.25*point[v2].z)
	  +0.125*(point[top].z + point[bottom].z);
      }else{
	out.x = (0.25*point[v1].x + 0.5*point[v2].x)
	  +0.125*(point[top].x + point[bottom].x);
	out.y = (0.25*point[v1].y + 0.5*point[v2].y)
	  +0.125*(point[top].y + point[bottom].y);
	out.z = (0.25*point[v1].z + 0.5*point[v2].z)
	  +0.125*(point[top].z + point[bottom].z);
      }
      
    }else{
      IDList nowv1 = FHead[v1];
      int top=0;
      int bottom=0;
      int i=0;
      boolean bbcheck=true;
      while(next(nowv1)!=FTail[v1]){
	nowv1 = next(nowv1);
	i = checktopbottomLR(nowv1.ID,v1,v2);
	if(i!=-1){
	  if(bbcheck){
	    top = i;
	    bbcheck=false;
	  }else{
	    if(i!=top){
	      bottom=i;
	    break;
	    }
	  }
	}
      }
      out.x = 0.375*(point[v1].x + point[v2].x)
	+0.125*(point[top].x + point[bottom].x);
      out.y = 0.375*(point[v1].y + point[v2].y)
	+0.125*(point[top].y + point[bottom].y);
      out.z = 0.375*(point[v1].z + point[v2].z)
	+0.125*(point[top].z + point[bottom].z);
    
    }
  }


    private void setModTC(Point3d out,int v1,int v2){
    
    
      out.x = 0.5*(point[v1].x + point[v2].x);
      out.y = 0.5*(point[v1].y + point[v2].y);
      out.z = 0.5*(point[v1].z + point[v2].z);
    
  }
private void setModTCOdd(Point3d out,int dv){
    double beta=(2.0/3.0);
    double dvalance=((double)(neighborI[dv]));
    double dx=0.0;
    double dy=0.0;
    double dz=0.0;
    double weight=(1.0/(3.0*dvalance));
    IDList now = IHead[dv];
    
      int did1=0;
      int did2=0;
      boolean scheck=true;
      
      now = IHead[dv];
      while(next(now)!=ITail[dv]){
	now = next(now);
	
	dx += weight*point[now.ID].x;      
	dy += weight*point[now.ID].y;      
	dz += weight*point[now.ID].z;      
      }
      dx += beta*point[dv].x;
      dy += beta*point[dv].y;
      dz += beta*point[dv].z;
      out.x = dx;
      out.y = dy;
      out.z = dz;

    


}
  private void setModLoopOdd(Point3d out,int dv){
    double beta=0.0;
    double dvalance=((double)(neighborI[dv]));
    double dx=0.0;
    double dy=0.0;
    double dz=0.0;
    double weight=((1.0/dvalance)*((5.0/8.0)-Math.pow(((3.0/8.0)+0.25*Math.cos(((2.0*Math.PI)/dvalance))),2.0)));
    IDList now = IHead[dv];
    if(boundary[dv]==1){
      int did1=0;
      int did2=0;
      boolean scheck=true;
      now = IHead[dv];
      while(next(now)!=ITail[dv]){
	now = next(now);
	if(boundary[now.ID]==1){
	  if(scheck){
	    did1 = now.ID;
	    scheck = false;
	  }else{
	    if(now.ID != did1){
	      did2 = now.ID;
	      break;
	    }
	  }
	}
      }
      
      out.x = (3.0/4.0)*point[dv].x + (1.0/8.0)*(point[did1].x + point[did2].x);
      out.y = (3.0/4.0)*point[dv].y + (1.0/8.0)*(point[did1].y + point[did2].y);
      out.z = (3.0/4.0)*point[dv].z + (1.0/8.0)*(point[did1].z + point[did2].z);
      

    }else{
      now = IHead[dv];
      while(next(now)!=ITail[dv]){
	now = next(now);
	dx += weight*point[now.ID].x;
	dy += weight*point[now.ID].y;
	dz += weight*point[now.ID].z;
	
      }
      dx += (1.0-(dvalance*weight))*point[dv].x;
      dy += (1.0-(dvalance*weight))*point[dv].y;
      dz += (1.0-(dvalance*weight))*point[dv].z;
      out.x = dx;
      out.y = dy;
      out.z = dz;
      
      
    }
    
  }
    

  private void  SubDivideLoopSetLimit(){
    int i=0;
    IDList now;
    double dx=0.0;
    double dy=0.0;
    double dz=0.0;
    double weight=0.0;
    double beta = 0.0;
    double dvalance=1.0;
    for(i=0;i<numberV;i++){
      dx=0.0;
      dy=0.0;
      dz=0.0;
      
      dvalance = ((double)(neighborI[i]));
      beta =((1.0/dvalance)*((5.0/8.0)-Math.pow(((3.0/8.0)+0.25*Math.cos(((2.0*Math.PI)/dvalance))),2.0)));
      weight=(1.0/((3.0/8.0)*beta+dvalance));
      now = IHead[i];
      while(next(now)!=ITail[i]){
	now = next(now);
	dx += weight*point[now.ID].x;
	dy += weight*point[now.ID].y;
	dz += weight*point[now.ID].z;
      }
      dx += (1.0-(dvalance*weight))*point[i].x;
      dy += (1.0-(dvalance*weight))*point[i].y;
      dz += (1.0-(dvalance*weight))*point[i].z;
      laplace[i].x = dx;
      laplace[i].y = dy;
      laplace[i].z = dz;
    }
    for(i=0;i<numberV;i++){
      point[i].x = laplace[i].x;
      point[i].y = laplace[i].y;
      point[i].z = laplace[i].z;
      KnotInit[i].x = point[i].x;
      KnotInit[i].y = point[i].y;
      KnotInit[i].z = point[i].z;
      

    }
    for(i=0;i<numberV;i++){
      dx=0.0;
      dy=0.0;
      dz=0.0;
      
      dvalance = ((double)(neighborI[i]));
      now = IHead[i];
      while(next(now)!=ITail[i]){
	now = next(now);
	dx += (point[now.ID].x-point[i].x);
	dy += (point[now.ID].y-point[i].y);
	dz += (point[now.ID].z-point[i].z);
      }
      dx /= dvalance;
      dy /= dvalance;
      dz /= dvalance;
      
      laplace[i].x = dx;
      laplace[i].y = dy;
      laplace[i].z = dz;
    }
    

  }
    
private void  SubDivideTCSetLimit(){
    int i=0;
    IDList now;
    double dx=0.0;
    double dy=0.0;
    double dz=0.0;
    double weight=0.0;
    double beta = 0.0;
    double dvalance=1.0;beta =(3.0/5.0);
    for(i=0;i<numberV;i++){
      dx=0.0;
      dy=0.0;
      dz=0.0;
      
      weight = (2.0/(5.0*((double)(neighborI[i]))));
      
      
      now = IHead[i];
      while(next(now)!=ITail[i]){
	now = next(now);
	dx += weight*point[now.ID].x;
	dy += weight*point[now.ID].y;
	dz += weight*point[now.ID].z;
      }
      dx += beta*point[i].x;
      dy += beta*point[i].y;
      dz += beta*point[i].z;
      laplace[i].x = dx;
      laplace[i].y = dy;
      laplace[i].z = dz;
    }
    for(i=0;i<numberV;i++){
      point[i].x = laplace[i].x;
      point[i].y = laplace[i].y;
      point[i].z = laplace[i].z;
      KnotInit[i].x = point[i].x;
      KnotInit[i].y = point[i].y;
      KnotInit[i].z = point[i].z;
      

    }
    
    for(i=0;i<numberV;i++){
      dx=0.0;
      dy=0.0;
      dz=0.0;
      
      dvalance = ((double)(neighborI[i]));
      now = IHead[i];
      while(next(now)!=ITail[i]){
	now = next(now);
	dx += (point[now.ID].x-point[i].x);
	dy += (point[now.ID].y-point[i].y);
	dz += (point[now.ID].z-point[i].z);
      }
      dx /= dvalance;
      dy /= dvalance;
      dz /= dvalance;
      
      laplace[i].x = dx;
      laplace[i].y = dy;
      laplace[i].z = dz;
    }
    

  }
    
  public void SubDivideLoop(){
    int i,j;
    
    Point3d tmpposition = new Point3d(0.0,0.0,0.0);
    int numberVnew = numberV + numberE;
    int numberFnew = 4*numberF;
    System.out.println("new numberV = "+numberVnew);
    System.out.println("new numberF = "+numberFnew);
    
    subpoint = new Point3d[numberVnew];
    subFace = new int[numberFnew][3];
   
    
    int Dface[][] = new int[numberV][numberV];
   
    for(i=0;i<numberV;i++){
      setModLoopOdd(tmpposition,i);
      subpoint[i] = new Point3d(tmpposition.x,tmpposition.y,tmpposition.z);
      //subpoint[i] = new Point3d(point[i].x,point[i].y,point[i].z);
    }
    int vpointer=numberV;
    for(i=0;i<numberF;i++){
      
     if(Dface[Face[i][0]][Face[i][1]]==0){
       
       setModLoop(tmpposition,Face[i][0],Face[i][1]);
       subpoint[vpointer] = new Point3d(tmpposition.x,tmpposition.y,tmpposition.z);
       Dface[Face[i][0]][Face[i][1]] = vpointer;
       Dface[Face[i][1]][Face[i][0]] = vpointer;
       vpointer++;
     }
     if(Dface[Face[i][1]][Face[i][2]]==0){
       setModLoop(tmpposition,Face[i][1],Face[i][2]);
       subpoint[vpointer] = new Point3d(tmpposition.x,tmpposition.y,tmpposition.z);
       Dface[Face[i][1]][Face[i][2]] = vpointer;
       Dface[Face[i][2]][Face[i][1]] = vpointer;
       vpointer++;
     }
     if(Dface[Face[i][2]][Face[i][0]]==0){ 
       setModLoop(tmpposition,Face[i][2],Face[i][0]);
       
       subpoint[vpointer] = new Point3d(tmpposition.x,tmpposition.y,tmpposition.z);
       Dface[Face[i][2]][Face[i][0]] = vpointer;
       Dface[Face[i][0]][Face[i][2]] = vpointer;
       vpointer++;
     } 
     
    }
    //System.out.println("vpointer = "+vpointer);
    for(i=0;i<numberF;i++){
      subFace[4*i][0] = Face[i][0];
      subFace[4*i][1] = Dface[Face[i][0]][Face[i][1]];
      subFace[4*i][2] = Dface[Face[i][2]][Face[i][0]];
      
      subFace[4*i+1][0] = Dface[Face[i][0]][Face[i][1]];
      subFace[4*i+1][1] = Face[i][1];
      subFace[4*i+1][2] = Dface[Face[i][1]][Face[i][2]];
      
      subFace[4*i+2][0] = Dface[Face[i][2]][Face[i][0]];
      subFace[4*i+2][1] = Dface[Face[i][1]][Face[i][2]];
      subFace[4*i+2][2] = Face[i][2];
      
      subFace[4*i+3][0] = Dface[Face[i][0]][Face[i][1]];
      subFace[4*i+3][1] = Dface[Face[i][1]][Face[i][2]];
      subFace[4*i+3][2] = Dface[Face[i][2]][Face[i][0]];
            
    }
    
    int prenum = numberV;
    
    

    numberV = numberVnew;
    numberF = numberFnew;
    numberE = numberVnew + numberFnew - EulerC;
     UpdatePolyStructure();
  }
  
  public void SubDivideTcenter(){
    int i,j;
    
    Point3d tmpposition = new Point3d(0.0,0.0,0.0);
    int numberVnew = numberV + numberE;
    int numberFnew = 4*numberF;
    System.out.println("new numberV = "+numberVnew);
    System.out.println("new numberF = "+numberFnew);
    
    subpoint = new Point3d[numberVnew];
    subFace = new int[numberFnew][3];
   
    
    int Dface[][] = new int[numberV][numberV];
   
    for(i=0;i<numberV;i++){
      setModTCOdd(tmpposition,i);
      subpoint[i] = new Point3d(tmpposition.x,tmpposition.y,tmpposition.z);
      //subpoint[i] = new Point3d(point[i].x,point[i].y,point[i].z);
    }
    int vpointer=numberV;
    for(i=0;i<numberF;i++){
      
     if(Dface[Face[i][0]][Face[i][1]]==0){
       
       setModLoop(tmpposition,Face[i][0],Face[i][1]);
       subpoint[vpointer] = new Point3d(tmpposition.x,tmpposition.y,tmpposition.z);
       Dface[Face[i][0]][Face[i][1]] = vpointer;
       Dface[Face[i][1]][Face[i][0]] = vpointer;
       vpointer++;
     }
     if(Dface[Face[i][1]][Face[i][2]]==0){
       setModLoop(tmpposition,Face[i][1],Face[i][2]);
       subpoint[vpointer] = new Point3d(tmpposition.x,tmpposition.y,tmpposition.z);
       Dface[Face[i][1]][Face[i][2]] = vpointer;
       Dface[Face[i][2]][Face[i][1]] = vpointer;
       vpointer++;
     }
     if(Dface[Face[i][2]][Face[i][0]]==0){ 
       setModLoop(tmpposition,Face[i][2],Face[i][0]);
       
       subpoint[vpointer] = new Point3d(tmpposition.x,tmpposition.y,tmpposition.z);
       Dface[Face[i][2]][Face[i][0]] = vpointer;
       Dface[Face[i][0]][Face[i][2]] = vpointer;
       vpointer++;
     } 
     
    }
    //System.out.println("vpointer = "+vpointer);
    for(i=0;i<numberF;i++){
      subFace[4*i][0] = Face[i][0];
      subFace[4*i][1] = Dface[Face[i][0]][Face[i][1]];
      subFace[4*i][2] = Dface[Face[i][2]][Face[i][0]];
      
      subFace[4*i+1][0] = Dface[Face[i][0]][Face[i][1]];
      subFace[4*i+1][1] = Face[i][1];
      subFace[4*i+1][2] = Dface[Face[i][1]][Face[i][2]];
      
      subFace[4*i+2][0] = Dface[Face[i][2]][Face[i][0]];
      subFace[4*i+2][1] = Dface[Face[i][1]][Face[i][2]];
      subFace[4*i+2][2] = Face[i][2];
      
      subFace[4*i+3][0] = Dface[Face[i][0]][Face[i][1]];
      subFace[4*i+3][1] = Dface[Face[i][1]][Face[i][2]];
      subFace[4*i+3][2] = Dface[Face[i][2]][Face[i][0]];
            
    }
    
    int prenum = numberV;
    
    

    numberV = numberVnew;
    numberF = numberFnew;
    numberE = numberVnew + numberFnew - EulerC;
     UpdatePolyStructure();
  }
  
  
  public void SubDivide(){
    System.out.println("SubDivide Polygonal Surface by Linear 1 to 4 Face Split.");
    int i,j;
    double dx=0.0;
    double dy=0.0;
    double dz=0.0;
  
    int numberVnew = numberV + numberE;
    int numberFnew = 4*numberF;
    System.out.println("new numberV = "+numberVnew);
    System.out.println("new numberF = "+numberFnew);
    
    subpoint = new Point3d[numberVnew];
    subFace = new int[numberFnew][3];
    
    
    int Dface[][] = new int[numberV][numberV];
    
    
    /*
      Check !!!
      If Dface[i][j] does not initialized by zero, we must set zero. 
      for(i=0;i<numberV;i++)
      for(j=0;j<numberV;j++){
      System.out.println("Dface[i][j] = "+Dface[i][j]);
      Dface[i][j] = -1;
      
      }
      */
    System.out.println("Start subdivision ");
    for(i=0;i<numberV;i++){
      subpoint[i] = new Point3d(point[i].x,point[i].y,point[i].z);
    }
    int vpointer=numberV;
    for(i=0;i<numberF;i++){
      
      if(Dface[Face[i][0]][Face[i][1]]==0){
	dx = (point[Face[i][0]].x + point[Face[i][1]].x)/2.0;
	dy = (point[Face[i][0]].y + point[Face[i][1]].y)/2.0;
	dz = (point[Face[i][0]].z + point[Face[i][1]].z)/2.0;
	subpoint[vpointer] = new Point3d(dx,dy,dz);
	Dface[Face[i][0]][Face[i][1]] = vpointer;
	Dface[Face[i][1]][Face[i][0]] = vpointer;
	vpointer++;
      }
      if(Dface[Face[i][1]][Face[i][2]]==0){
	dx = (point[Face[i][1]].x + point[Face[i][2]].x)/2.0;
	dy = (point[Face[i][1]].y + point[Face[i][2]].y)/2.0;
	dz = (point[Face[i][1]].z + point[Face[i][2]].z)/2.0;
	subpoint[vpointer] = new Point3d(dx,dy,dz);
	Dface[Face[i][1]][Face[i][2]] = vpointer;
	Dface[Face[i][2]][Face[i][1]] = vpointer;
	vpointer++;
      }
      if(Dface[Face[i][2]][Face[i][0]]==0){ 
	dx = (point[Face[i][2]].x + point[Face[i][0]].x)/2.0;
	dy = (point[Face[i][2]].y + point[Face[i][0]].y)/2.0;
	dz = (point[Face[i][2]].z + point[Face[i][0]].z)/2.0;
	subpoint[vpointer] = new Point3d(dx,dy,dz);
	Dface[Face[i][2]][Face[i][0]] = vpointer;
	Dface[Face[i][0]][Face[i][2]] = vpointer;
	vpointer++;
      } 
            
    }
    //System.out.println("vpointer = "+vpointer);
    for(i=0;i<numberF;i++){
      subFace[4*i][0] = Face[i][0];
      subFace[4*i][1] = Dface[Face[i][0]][Face[i][1]];
      subFace[4*i][2] = Dface[Face[i][2]][Face[i][0]];
      
      subFace[4*i+1][0] = Dface[Face[i][0]][Face[i][1]];
      subFace[4*i+1][1] = Face[i][1];
      subFace[4*i+1][2] = Dface[Face[i][1]][Face[i][2]];
      
      subFace[4*i+2][0] = Dface[Face[i][2]][Face[i][0]];
      subFace[4*i+2][1] = Dface[Face[i][1]][Face[i][2]];
      subFace[4*i+2][2] = Face[i][2];
      
      subFace[4*i+3][0] = Dface[Face[i][0]][Face[i][1]];
      subFace[4*i+3][1] = Dface[Face[i][1]][Face[i][2]];
      subFace[4*i+3][2] = Dface[Face[i][2]][Face[i][0]];
            
    }
    
    int prenum = numberV;
        
    numberV = numberVnew;
    numberF = numberFnew;
    numberE = numberVnew + numberFnew - EulerC;
    UpdatePolyStructure();    
  }
    
  private void UpdatePolyStructure(){
    memoryallocation(numberV,numberF);
    int i,j,k;
    System.out.println("Init finish.");
    double dx=0.0;
    double dy=0.0;
    double dz=0.0;
    double maxvalue = 0.0;
    for(i=0;i<numberV;i++){
      dx = subpoint[i].x;
      dy = subpoint[i].y;
      dz = subpoint[i].z;
      if(maxvalue<Math.abs(dx))maxvalue = Math.abs(dx);
      if(maxvalue<Math.abs(dy))maxvalue = Math.abs(dy);
      if(maxvalue<Math.abs(dz))maxvalue = Math.abs(dz);
      InitializeData(i,dx,dy,dz);
    }
    System.out.println("Now Finish Read Vertices.");
    if(maxvalue != 0.0){
      //scaler = 1.0/maxvalue;
      System.out.println("scaler = "+scaler);
     /* for(i=0;i<numberV;i++){
	point[i].x *= scaler;
	point[i].y *= scaler;
	point[i].z *= scaler;
	KnotInit[i].x *= scaler;
	KnotInit[i].y *= scaler;
	KnotInit[i].z *= scaler;
      }*/
    }
    System.out.println("Finish Scaling");
    int di,dj,dk;
    
    Vector3d ddnormal = new Vector3d();
    Vector3d v1 = new Vector3d();
    Vector3d v2 = new Vector3d();
    
    
    int dummm;
    for(i=0;i<numberF;i++){
      di = subFace[i][0];
      dj = subFace[i][1];
      dk = subFace[i][2];
      MakeFace(i,di,dj,dk);
    }
    
    System.out.println("Finish Read Faces.");
    this.SetBoundaryStrips();
    
    MakeArrayData();
    System.out.println("Finish Update Data Section.");
   
  }
  public void setCInitPosition(){
    int i,j;
    for(i=0;i<numberV;i++){
      
      KnotInit[i].x = point[i].x;
      KnotInit[i].y = point[i].y;
      KnotInit[i].z = point[i].z;
      
      
      
    }    
    setMeanCurvature();
    UpdatePolygon();
    //MakeArrayData();
  }
  public void InitPosition(){
    int i,j;
    for(i=0;i<numberV;i++){
      
      point[i].x = KnotInit[i].x;
      point[i].y = KnotInit[i].y;
      point[i].z = KnotInit[i].z;
      
      
    }    
    
    setMeanCurvature();
    UpdatePolygon();
    //MakeArrayData();
  }
    
    public void MakeNormals(Point3d [] normal){
	int i,j;
    Point3d[] dv = new Point3d[4];
    IDList now;
    
    for(i=0;i<4;i++)dv[i] = new Point3d(0.0,0.0,0.0);
    
    
    double dummytemp=0.0;
    
   
    for(i=0;i<numberV;i++){
      if(boundary[i] !=1){
	
	now = VHead[i];
	
	for(j=0;j<4;j++){
	  dv[j].x = 0.0;dv[j].y = 0.0;dv[j].z = 0.0;
	}
	
	while(next(now)!=VTail[i]){
	  now = next(now);
	  
	  this.makeVector(dv[0],point[i],point[next(now).ID]);
	
	  this.makeVector(dv[1],point[i],point[now.ID]);
	
	  this.CrossVector(dv[2],dv[1],dv[0]);
	  dv[3].x += dv[2].x;
	  dv[3].y += dv[2].y;
	  dv[3].z += dv[2].z;
	
	  now = next(now);
	}
	dummytemp = Point3dSize(dv[3]);
	if(dummytemp != 0.0){
	  normal[i].x = ((dv[3].x)/dummytemp);
	  normal[i].y = ((dv[3].y)/dummytemp);
	  normal[i].z = ((dv[3].z)/dummytemp);
	}
	
      }else{
	
	now = VHead[i];
	
	for(j=0;j<4;j++){
	  dv[j].x = 0.0;dv[j].y = 0.0;dv[j].z = 0.0;
	}
	
	while(next(now)!=VTail[i]){
	  now = next(now);
	  
	  this.makeVector(dv[0],point[i],point[next(now).ID]);
	  this.makeVector(dv[1],point[i],point[now.ID]);
	 
	  this.CrossVector(dv[2],dv[1],dv[0]);
	  dv[3].x += dv[2].x;
	  dv[3].y += dv[2].y;
	  dv[3].z += dv[2].z;
	  
	 
	  now = next(now);
	}
	dummytemp = Point3dSize(dv[3]);
	if(dummytemp != 0.0){
	  normal[i].x = ((dv[3].x)/dummytemp);
	  normal[i].y = ((dv[3].y)/dummytemp);
	  normal[i].z = ((dv[3].z)/dummytemp);
	}
      }
	
    }
    
    
    }
  public void Flow(int ftype,int numenettimes){
    int i,j;
    double dx,dy,dz,epsilon;
    Point3d tangent = new Point3d(0.0,0.0,0.0);
    Point3d dumlblbs = new Point3d(0.0,0.0,0.0);
    Point3d mydlap = new Point3d(0.0,0.0,0.0);
    
    RefleshBE();
     if(ftype==0){
      //System.out.println("Check !!!");
       for(i=0;i<numenettimes;i++){
	PropertyL(laplace,point);
	PropertyL(bilaplace,laplace);
	MakeTangentsBAfterL(laplace,point);
	MakeNormals(laplace);
	for(j=0;j<numberV;j++){
	  if(boundary[j]!=1){
	    bilaplace[j].x *= -1.0;
	    bilaplace[j].y *= -1.0;
	    bilaplace[j].z *= -1.0;
	    
	    
	    ProjectionM(tangent,bilaplace[j],laplace[j]);
	    dx = point[j].x + 0.5*(tangent.x);
	    dy = point[j].y + 0.5*(tangent.y);
	    dz = point[j].z + 0.5*(tangent.z);
	    (point[j]).x = dx;
	    (point[j]).y = dy;
	    (point[j]).z = dz;
	  }else{
	    IDList now = VHead[j];
	    
	    while(next(now)!=VTail[j]){
	      now = next(now);
	      AppendBE(now.ID);
	      now = next(now);
	      AppendBE(now.ID);
	    }
	    tangent.x = laplace[j].x;
	   tangent.y = laplace[j].y;
	   tangent.z = laplace[j].z; 
	mydlap.x = 0.5*(bilaplace[next(BEHead).ID].x -2.0*bilaplace[j].x 
+ bilaplace[back(BETail).ID].x);
	mydlap.y = 0.5*(bilaplace[next(BEHead).ID].y -2.0*bilaplace[j].y 
+ bilaplace[back(BETail).ID].y);
	mydlap.z = 0.5*(bilaplace[next(BEHead).ID].z -2.0*bilaplace[j].z 
+ bilaplace[back(BETail).ID].z);
	   
	 	  
	    RefleshBE();
	  
	    mydlap.x *= -1.0;
	    mydlap.y *= -1.0;
	    mydlap.z *= -1.0;
	    
	    dumlblbs.x = InnerProduct(mydlap,tangent)*tangent.x;
	    dumlblbs.y = InnerProduct(mydlap,tangent)*tangent.y;
	    dumlblbs.z = InnerProduct(mydlap,tangent)*tangent.z;
	  	   
	    ProjectionM(tangent,dumlblbs,laplace[j]);
	    dx = point[j].x + 0.5*(tangent.x);
	    dy = point[j].y + 0.5*(tangent.y);
	    dz = point[j].z + 0.5*(tangent.z);
	    (point[j]).x = dx;
	    (point[j]).y = dy;
	    (point[j]).z = dz;
	    	    
	  }
	
	}
	System.out.print(".");
      }

    }else if(ftype==5){
	System.out.println("No Implementation");      
      
    }else if(ftype==2){
	/*
	for(i=0;i<numenettimes;i++){
	PropertyL(laplace,point);
	for(j=0;j<numberV;j++){
	  if(boundary[j]!=1){
	    dx = point[j].x + 0.5*(laplace[j].x);
	    dy = point[j].y + 0.5*(laplace[j].y);
	    dz = point[j].z + 0.5*(laplace[j].z);
	    (point[j]).x = dx;
	    (point[j]).y = dy;
	    (point[j]).z = dz;
	  }
	}
	System.out.print(".");
      }
	*/
	for(i=0;i<numenettimes;i++){
	    
	    for(j=0;j<numberV;j++){
		 laplace[j].x= 0.0;
	    laplace[j].y= 0.0;
	    laplace[j].z= 0.0;
		IDList now = FHead[j];
    while(next(now)!=FTail[j]){
      now = next(now);
      laplace[j].x += (point[Face[now.ID][0]].x+point[Face[now.ID][1]].x+point[Face[now.ID][2]].x)/3.0;
      laplace[j].y += (point[Face[now.ID][0]].y+point[Face[now.ID][1]].y+point[Face[now.ID][2]].y)/3.0;
      laplace[j].z += (point[Face[now.ID][0]].z+point[Face[now.ID][1]].z+point[Face[now.ID][2]].z)/3.0;
      
    }
    laplace[j].x /= ((double)(neighborI[j]));
    laplace[j].y /= ((double)(neighborI[j]));
    laplace[j].z /= ((double)(neighborI[j]));
    
	    }
	   for(j=0;j<numberV;j++){
	       dx = (laplace[j].x);
	    dy = (laplace[j].y);
	    dz = (laplace[j].z);
	    (point[j]).x = dx;
	    (point[j]).y = dy;
	    (point[j]).z = dz;
	   } 
	    
	}
      
    }else if(ftype==3){
      for(i=0;i<numenettimes;i++){
	PropertyL(laplace,point);
	PropertyL(bilaplace,laplace);
	
	for(j=0;j<numberV;j++){
	  if(boundary[j]==0){
	    dx = point[j].x - (bilaplace[j].x)/6.0;
	    dy = point[j].y - (bilaplace[j].y)/6.0;
	    dz = point[j].z - (bilaplace[j].z)/6.0;
	    (point[j]).x = dx;
	    (point[j]).y = dy;
	    (point[j]).z = dz;
	  }
	}
	System.out.print(".");
      }
    }else if(ftype==4){
       Random myrand = new Random();
       
      for(i=0;i<numenettimes;i++){
	
	for(j=0;j<numberV;j++){
	  if(boundary[j]!=1){
	    
	    dx = ((double)(((int)((double)(25.0*point[j].x)))))/25.0;
	    dy = ((double)(((int)((double)(25.0*point[j].y)))))/25.0;
	    dz = ((double)(((int)((double)(25.0*point[j].z)))))/25.0;
	    
	    (point[j]).x = dx;
	    (point[j]).y = dy;
	    (point[j]).z = dz;
	  }
	}
	System.out.print(".");
      }
    }else if(ftype==19){
       Random myrand = new Random();
       
      for(i=0;i<numenettimes;i++){
	
	for(j=0;j<numberV;j++){
	  if(boundary[j]!=1){
	    
	    dx = 0.01*((double)(((int)((double)(100.0*point[j].x)))));
	    dy = 0.01*((double)(((int)((double)(100.0*point[j].y)))));
	    dz = 0.01*((double)(((int)((double)(100.0*point[j].z)))));
	    
	    (point[j]).x = dx;
	    (point[j]).y = dy;
	    (point[j]).z = dz;
	  }
	}
	System.out.print(".");
      }
    }else if(ftype==20){
       Random myrand = new Random();
       
      for(i=0;i<numenettimes;i++){
	
	for(j=0;j<numberV;j++){
	  if(boundary[j]!=1){
	    
	    dx = 10.0*((double)(((int)((double)(0.1*point[j].x)))));
	    dy = 10.0*((double)(((int)((double)(0.1*point[j].y)))));
	    dz = 10.0*((double)(((int)((double)(0.1*point[j].z)))));
	    
	    (point[j]).x = dx;
	    (point[j]).y = dy;
	    (point[j]).z = dz;
	  }
	}
	System.out.print(".");
      }
    }else if(ftype==21){Random myrand = new Random();
	double avv=0.0;
	double divi=0.0;
	PropertyL(laplace,point);
        for(j=0;j<numberV;j++){if(boundary[j]!=1){
	    avv+=Point3dSize(laplace[j]);divi+=1.0;
	}
	}
	if(divi!=0.0)avv/=divi;
      for(i=0;i<numenettimes;i++){
	MakeNormals(laplace);
	PropertyL(laplace,point);
	for(j=0;j<numberV;j++){
	  if(boundary[j]!=1){
	    epsilon = (1.0/scaler)*avv*(myrand.nextDouble() - 0.5);
	    dx = point[j].x + epsilon*(laplace[j].x);
	    dy = point[j].y + epsilon*(laplace[j].y);
	    dz = point[j].z + epsilon*(laplace[j].z);
	    (point[j]).x = dx;
	    (point[j]).y = dy;
	    (point[j]).z = dz;
	  }
	}
	System.out.print(".");
      }
    }else if(ftype==22){Random myrand2 = new Random();Random myrand = new Random();
	double avv=0.0;
	double divi=0.0;
	PropertyL(laplace,point);
        for(j=0;j<numberV;j++){if(boundary[j]!=1){
	    avv+=Point3dSize(laplace[j]);divi+=1.0;
	}
	}
	if(divi!=0.0)avv/=divi;
      for(i=0;i<numenettimes;i++){
	MakeNormals(laplace);
	PropertyL(laplace,point);
	for(j=0;j<numberV;j++){
	  if(boundary[j]!=1&&myrand2.nextDouble()<0.01){
	    epsilon = (1.5/scaler)*avv*(myrand.nextDouble() - 0.5);
	    dx = point[j].x + epsilon*(laplace[j].x);
	    dy = point[j].y + epsilon*(laplace[j].y);
	    dz = point[j].z + epsilon*(laplace[j].z);
	    (point[j]).x = dx;
	    (point[j]).y = dy;
	    (point[j]).z = dz;
	  }
	}
	System.out.print(".");
      }
    }
  
    
     setMeanCurvature();//PropertyUpdate();
    UpdatePolygon();
      
  }
  public void makeVector(Point3d out,Point3d in1,Point3d in2){
    out.x = (in2.x - in1.x);
    out.y = (in2.y - in1.y);
    out.z = (in2.z - in1.z);
  }
  public void CrossVector(Point3d out,Point3d in1,Point3d in2){
  out.x = (in1.y*in2.z - in2.y*in1.z);
  out.y = (in1.z*in2.x - in2.z*in1.x);
  out.z = (in1.x*in2.y - in2.x*in1.y);
  }
  public double InnerProduct(Point3d in1,Point3d in2){
    return (in1.x*in2.x + in1.y*in2.y + in1.z*in2.z);
  }
  public void ScalarVector(Point3d out,double dv,Point3d in){
    out.x = (dv*in.x);
    out.y = (dv*in.y);
    out.z = (dv*in.z);
  }
  
  public double Point3dSize(Point3d in){
    return Math.sqrt(((in.x*in.x)+(in.y*in.y)+(in.z*in.z)));
  }
  public double Distance(Point3d in1,Point3d in2){
    return Math.sqrt((((in1.x-in2.x)*(in1.x-in2.x))
		      +((in1.y-in2.y)*(in1.y-in2.y))
		      +((in1.z-in2.z)*(in1.z-in2.z))));
		      
  }
  private void ProjectionM(Point3d myproj,Point3d target,Point3d dnormal){
   double dmywe = (target.x*dnormal.x + target.y*dnormal.y + target.z*dnormal.z);
    myproj.x = (target.x - dmywe*dnormal.x);
    myproj.y = (target.y - dmywe*dnormal.y);
    myproj.z = (target.z - dmywe*dnormal.z);
  }/*
  private void ProjectionM(Point3d myproj,Point3d target,Point3d dnormal){
    double dmywe = (-target.x*dnormal.x - target.y*dnormal.y - target.z*dnormal.z);
    myproj.x = (-target.x - dmywe*dnormal.x);
    myproj.y = (-target.y - dmywe*dnormal.y);
    myproj.z = (-target.z - dmywe*dnormal.z);
  }*/
  public void Subdivision(int stype,int numenettimes){
    
    SetBoundaryLines();
    if(stype==0){/* Loop */
      for(int i=0;i<numenettimes;i++){
	SubDivideLoop();
	
      }
      SubDivideLoopSetLimit();
    }else if(stype==1){/* Butterfly */
      for(int i=0;i<numenettimes;i++){
	SubDivideModButterfly();
	
      }
    }else if(stype==2){/* Linear */
      for(int i=0;i<numenettimes;i++){
	SubDivide();
	
      }
    }else if(stype==3){/* Linear */
      for(int i=0;i<numenettimes;i++){
	SubDivideLoop();
	
      }
    }else if(stype==4){/* Tcenter */
      for(int i=0;i<numenettimes;i++){
	SubDivideTcenter();
	
      }
    }else if(stype==5){/* Tcenter */
      for(int i=0;i<numenettimes;i++){
	SubDivideTcenter();
	
      }
      SubDivideTCSetLimit();
    }
    SetBoundaryStrips();
    setMeanCurvature();//PropertyUpdate();
    UpdatePolygon();
  } 
 
  public void Decimation(double ddrp){
    int reduceN;
    int i;
    
    reduceN = ((int)((double)((ddrp/100.0)*((double)(numberV)))));
    
    if(numberV-reduceN<=3)reduceN=numberV-4;
    
    
    System.out.println("Reduction Ratio: "+ddrp+" %");
    System.out.println("May be V:"+numberV+" -> "+(numberV - reduceN));
    /* Make Intermediate Data structure and priority box */
    
    
    mydecimate = new GHDMesh(numberV,numberF,Face,point,boundary);
    mydecimate.Decimation((numberV - reduceN));
    
    
    /* Update Data Structure */
    subpoint = new Point3d[mydecimate.deciV];
    subFace = new int[mydecimate.deciF][3];
    System.out.println("mydecimate.deciF = "+mydecimate.deciF);
    System.out.println("mydecimate.deciV = "+mydecimate.deciV);
    int[] dddindex = new int[mydecimate.deciV];
    for(i=0;i<mydecimate.deciV;i++)dddindex[i] = 0;
    mydecimate.getVFace(subpoint,subFace,dddindex);
    

    numberV = mydecimate.deciV;
    numberF = mydecimate.deciF;
    numberE = numberV + numberF - EulerC;

    normalarray = new LineArray((numberV*2),GeometryArray.COORDINATES
				| GeometryArray.NORMALS);
    normalarray.setCapability(Geometry.ALLOW_INTERSECT);
    normalarray.setCapability(LineArray.ALLOW_COORDINATE_WRITE);
    normalarray.setCapability(LineArray.ALLOW_NORMAL_WRITE); 
    System.out.println("");
    System.out.println("New V:"+numberV+" F:"+numberF);
     mydecimate=null;
    UpdatePolyStructure();
    for(i=0;i<numberV;i++)index[i] = dddindex[i];
    setMeanCurvature();//PropertyUpdate();
    dddindex = null;

    UpdatePolygon();
  }
  private void updateNormalLine(){
    int i=0;
    MakeNormals(laplace);
    for(i=0;i<numberV;i++){
      mynormal[(2*i)].x = point[i].x*scaler;
      mynormal[(2*i)].y = point[i].y*scaler;
      mynormal[(2*i)].z = point[i].z*scaler;
      
      mynormal[(2*i+1)].x = point[i].x*scaler+0.085*laplace[i].x;
      mynormal[(2*i+1)].y = point[i].y*scaler+0.085*laplace[i].y;
      mynormal[(2*i+1)].z = point[i].z*scaler+0.085*laplace[i].z;
      
      mynormalnormal[(2*i)].x = ((float)(point[i].x*scaler));
      mynormalnormal[(2*i)].y = ((float)(point[i].y*scaler));
      mynormalnormal[(2*i)].z = ((float)(point[i].z*scaler));
      mynormalnormal[(2*i+1)].x = ((float)(mynormal[(2*i+1)].x));
      mynormalnormal[(2*i+1)].y = ((float)(mynormal[(2*i+1)].y));
      mynormalnormal[(2*i+1)].z = ((float)(mynormal[(2*i+1)].z));
      
    
    }
  
  }
    public int getFace(int i,int j,int fi){
	IDList now = FHead[i];
	int di,dj;
	int tID=-1;
	while(next(now)!=FTail[i]){
	  now = next(now); 
	  if(now.ID!=fi){
	    if((Face[now.ID][0]==i&&Face[now.ID][1]==j)||
	       (Face[now.ID][1]==i&&Face[now.ID][0]==j)||
	       (Face[now.ID][0]==i&&Face[now.ID][2]==j)||
	       (Face[now.ID][2]==i&&Face[now.ID][0]==j)||
	       (Face[now.ID][2]==i&&Face[now.ID][1]==j)||
	       (Face[now.ID][1]==i&&Face[now.ID][2]==j)){
	      
	      tID = now.ID;
	      break;
	    }
	    
	    
	  }
	  
	  
	}
	return tID;
    }
    public Point3d getPNN(int i){
	return new Point3d((scaler*point[i].x),(scaler*point[i].y),(scaler*point[i].z));
    }
    public Point3d getP(int i){
	double dx = scaler*(point[i].x)+0.0005*laplace[i].x;
	double dy = scaler*(point[i].y)+0.0005*laplace[i].y;
	double dz = scaler*(point[i].z)+0.0005*laplace[i].z;
	return new Point3d(dx,dy,dz);
	
    }
}
